<?php

/**
 *
 * ContentNow | Small Content Management System
 *
 * Copyright (C) 2005/2006 Andre Michaelis <kontakt@michaelis-freunde.de>
 *
 * This file may be distributed and/or modified under the terms of the
 * "GNU General Public License" version 2 as published by the Free
 * Software Foundation and appearing in the file LICENSE included in
 * the packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 *
 * The "GNU General Public License" (GPL) is available at
 * http://www.gnu.org/copyleft/gpl.html.
 * 
 */

	ob_start();

	// disable magic quotes
	set_magic_quotes_runtime (0);
	
	// show all errors, no warnings
	error_reporting (E_ALL & ~E_NOTICE);

	// get required classes
	if (file_exists('./require.php')) {
		require_once ('./require.php');
		require_once ('./library/class.thumbnail.php');	
	} else {
		die ('<span style="font:13px sans-serif;">Fatal error loading CMS. Please contact webmaster.</span>');
	}

	// check authentication	
	$cnSession = new cnSession();
	$cnSession->checkAuthentication();
	
	// make object
	$cnCore = new cnCore();
	$cnCore->secureCheckServerVars();	
	
	// get/set language
	$setLang= (empty ($_GET['lang'])) ? $cnCore->getBackendLanguage() : $_GET['lang'];
	$lang= $cnCore->setBackendLanguage($setLang);
	
	// get url params
	$getPath= empty ($_REQUEST['path']) ? $cnCore->checkForSecureVar('.') : $cnCore->checkForSecureVar($_REQUEST['path'],'/');
	$getIdentifier= empty ($_REQUEST['cid']) ? 'cid_not_configured' : $_REQUEST['cid'];
	$getFile= empty ($_REQUEST['file']) ? 'file_not_configured' : $_REQUEST['file'];
	$getSingle= empty ($_REQUEST['single']) ? 'false' : $_REQUEST['single'];
	$getFolder= empty ($_REQUEST['folder']) ? '' : $cnCore->checkForSecureVar($_REQUEST['folder']).'/';
	$getType= empty ($_REQUEST['type']) ? 'file' : $_REQUEST['type'];
	
	// fix ending backslash in folder path
	if (substr($getFolder, (strlen($getFolder) - 1)) == '/')
		$getCorrectedFolder= substr($getFolder, 0, (strlen($getFolder) - 1));
	
	// define path, check '/'s
	$path= $_SERVER['DOCUMENT_ROOT'];
	if (substr($path, (strlen($path) - 1)) == '/')
		$path= substr($path, 0, (strlen($path) - 1));
	
	// define absolute path
	$absolute_path= $path.$getPath.$getFolder;
	
	if ($_POST['resize']) {
			
			// fix ending slash
			$absolute_path .= '/';
		
			// default thumbsize
			$thumbsize_x= 500;
			$thumbsize_y= 250;
			
			// get requested image size
			$img_x = $_POST['imagesize_x'];
			$img_y = $_POST['imagesize_y'];
		
			// get actual image size
			$imagesize = getimagesize($absolute_path.$getFile);
			
			if ($imagesize[0] == $img_x && $imagesize[1] == $img_y) {
				// no resize needed
		
				echo $getFile.' (No resize needed)
					<br />
					<br />
					<img src="'.$getPath.$getFolder.'/'.$getFile.'" style="border: 1px solid #CCC;">';
			} else {
				// resize image
				$new_image = new Thumbnail($absolute_path.$getFile, $img_x, $img_y, 100);
				$temp_image_filename = substr($getFile, 0, -4).'_temp'.substr($getFile, -4);
				$new_image->save($absolute_path.$temp_image_filename);
				$new_imagesize = getimagesize($absolute_path.$temp_image_filename);
				$image_filename = substr($temp_image_filename, 0, -8).$new_imagesize[0].'x'.$new_imagesize[1].substr($getFile, -4);
				rename($absolute_path.$temp_image_filename, $absolute_path.$image_filename);
				
				echo 'Resizing done. New image saved to: '.$image_filename.'
				<br /><br />
				<img src="'.$getPath.$getFolder.'/'.$image_filename.'" style="border: 1px solid #CCC;">';
			}
			
			echo '<br /><br />
			<input type="button" onclick="changeUrl(\'./upload.php?path='.$getPath.'&folder='.$getFolder.'&cid='.$getIdentifier.'&type='.$getType.'&single='.$getSingle.'\');" value="'.$lang['button_back'].'" class="submit_120">';
			
	} else {
					
				$filedata= stat($absolute_path.$getFile);
				$size= round(($filedata[7] / 1024)).' kb';
				$size= $size > 1024 ? round(($size / 1024), 2).' MB' : $size;
				$imagesize = getimagesize($absolute_path.$getFile);
				$info= $size.' | '.$imagesize[0].' x '.$imagesize[1];			
					
				$text= $getFile.' ('.$info.')
				<br />
				<br />
				<img src="'.$getPath.$getFolder.$getFile.'" style="border: 1px solid #CCC;" id="newImage">
				<br />
				<br />
				<input type="button" onclick="changeUrl(\'./upload.php?path='.$getPath.'&folder='.$getCorrectedFolder.'&cid='.$getIdentifier.'&type='.$getType.'&single='.$getSingle.'\');" value="'.$lang['button_back'].'" class="submit_120">
				';
			
				if (file_exists($absolute_path.$getFile)) {
					
					$imagesize= getimagesize($absolute_path.$getFile);
					
					// calculate factor
					$jFactorHor = $imagesize[0] / $imagesize[1]; 
					$jFactorVer = $imagesize[1] / $imagesize[0];
					
					$content= '
								<li class="item">
									<div class="row">
										<!-- image param -->					
										<input type="text" id="imagesize_x" name="imagesize_x" value="'.$imagesize[0].'" onkeyup="$(\'imagesize_y\').value=getImageVars_x(this.value,document.getElementById(\'imagesize_y\'));" class="width_120">&nbsp;
										<input type="text" id="imagesize_y" name="imagesize_y" value="'.$imagesize[1].'" onkeyup="$(\'imagesize_x\').value=getImageVars_y(document.getElementById(\'imagesize_x\'),this.value);" class="width_120">&nbsp;
										<!-- ajax handler -->
										<script type="text/javascript" language="javascript">
										// <![CDATA[
											function getImageVars_x(img_dim_x,img_dim_y) {
												return Math.round(img_dim_x*'.$jFactorVer.');
											}
											function getImageVars_y(img_dim_x,img_dim_y) {
												return Math.round(img_dim_y*'.$jFactorHor.');
											}
											function writeImageVars() {
												var checkConfirm = confirm(\''.$lang['button_generate'].'?\');
												if (checkConfirm == true) {
													var opt = {
													    method: "post",
													    postBody: "resize=true&path='.$getPath.'&cid='.$getIdentifier.'&folder='.$getCorrectedFolder.'&file='.$getFile.'&type='.$getType.'&single='.$getSingle.'&imagesize_x="+document.getElementById(\'imagesize_x\').value+"&imagesize_y="+document.getElementById(\'imagesize_y\').value 
													}
													new Ajax.Updater(\'resultArea\',\'./image.php\', opt);
												} 
											}
											function previewImageVars() {
												$(\'newImage\').style.width=$(\'imagesize_x\').value+\'px\';
											}
										// ]]>
										</script>
										<input type="button" class="submit_120" name="previewImageVars" value="'.$lang['button_generate_preview'].'" onclick="previewImageVars();">
										<input type="button" class="submit_120" name="writeImageVars" value="'.$lang['button_generate'].'" onclick="writeImageVars();">
									</div>
								</li>';
				
				} else {
					// no readable dir in $absolute_path
					$content= '<li class="item"><div class="row">Error (Path: '.$absolute_path.')</div></li>';
				}
				
				$displayObj= '
						<p class="head">'.$lang['link_config'].'</p>
							<ul>'.$content.'</ul>
						<p class="head">'.$lang['link_preview'].'</p>
							<ul><li class="item">
								<div class="row"><div id="resultArea" name="resultArea" style="overflow:hidden;">'.$text.'</div></div>
								</li>
							</ul>
						';
						
				// Init smarty
				$smarty= new Smarty();
				$smarty->template_dir= CN_SKINDIR;
				$smarty->compile_dir= 'smarty/templates_cn';
				$smarty->cache_dir= 'smarty/cache';
				$smarty->config_dir= 'smarty/configs';
				
				$smarty->assign('cnSkinDir', CN_SKINDIR);
				
				$smarty->assign('contentDisplay', $displayObj);
				$displayUpload= $smarty->fetch('_upload.html');
				$smarty->assign('content', $displayUpload);
				
				$smarty->display('_page_upload.html');						
	}
				
	ob_end_flush();
	
?>