<?php

/**
 *
 * ContentNow | Small Content Management System
 *
 * Copyright (C) 2005/2006 Andre Michaelis <kontakt@michaelis-freunde.de>
 *
 * This file may be distributed and/or modified under the terms of the
 * "GNU General Public License" version 2 as published by the Free
 * Software Foundation and appearing in the file LICENSE included in
 * the packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 *
 * The "GNU General Public License" (GPL) is available at
 * http://www.gnu.org/copyleft/gpl.html.
 * 
 */

include('../library/configure.local.php');
include('../adodb/adodb.inc.php');

$table= array ();

$cn_config= CN_TBL_CONFIG;
$cn_content= CN_TBL_CONTENT;
$cn_sections= CN_TBL_SECTIONS;
$cn_sections_seq= CN_TBL_SECTIONS."_seq";
$cn_modul= CN_TBL_MODUL;
$cn_sessions= CN_TBL_SESSIONS;

// new admin user
$cn_adminuser= empty($_POST['adminuser']) ? CN_ADMIN_USER : $_POST['adminuser'];
$cn_adminpass= empty($_POST['adminpassword']) ? CN_ADMIN_PASS : $_POST['adminpassword'];
$cn_adminname= empty($_POST['adminname']) ? CN_WEBMASTER_NAME : $_POST['adminname'];
$cn_adminemail= empty($_POST['adminemail']) ? CN_WEBMASTER_EMAIL : $_POST['adminemail'];

// local config
$cn_dbuser= $_POST['dbuser'];
$cn_dbname= $_POST['dbname'];
$cn_dbpassword= $_POST['dbpassword'];
$cn_dbhost= empty($_POST['dbhost']) ? 'localhost' : $_POST['dbhost'];

$rootPath= $_SERVER['DOCUMENT_ROOT'];
if (substr($rootPath, (strlen($rootPath) - 1)) == '/')
	$rootPath= substr($rootPath, 0, (strlen($rootPath) - 1));

$confDir = str_replace('install','',$rootPath.CN_ROOTDIR.'library/');
$confFile = $confDir.'configure.php';
$confLocalFile = $confDir.'configure.local.php';
$destPath = str_replace('cn/library/','upload/configure.tmp',$confDir);
$rootDir = str_replace('cn/library/','',$confDir);

// check for cn/library writable and checks IP at home.
if (substr($_SERVER['REMOTE_ADDR'],0,7)!='192.168' && $_SERVER['REMOTE_ADDR']!='127.0.0.1')		{
	if (!is_writable($confDir)) die ('<span style="font:13px sans-serif;">Please make cn/library folder writable.<hr /><a href="index.php">Refresh</a></span>');
}

// check update
if (file_exists($destPath)) die ('<span style="font:13px sans-serif;">Installation found. Please run updater.<hr /><a href="update.php">Update</a></span>');

// define tables
$table[]= "DROP TABLE IF EXISTS `$cn_config`;";
$table[]= "CREATE TABLE `$cn_config` (
				`id` int(11) NOT NULL auto_increment,
				`startpageid` int(11) NOT NULL default '0',
				`teasercontentpageid` varchar(255) NOT NULL default '',
				`sitetitle` varchar(255) NOT NULL default '',
				`metainfo` text NOT NULL,
				`metadescription` text NOT NULL,
				`metakeywords` text NOT NULL,
				`globalsyskey` varchar(255) NOT NULL default '',
				`globalpageimage` varchar(255) NOT NULL default '',
				`pageimagetemplate` varchar(255) NOT NULL default '',
				`pagefootertemplate` varchar(255) NOT NULL default '',
				`pageheadertemplate` varchar(255) NOT NULL default '',
				`mastertemplate` varchar(255) NOT NULL default '',
				`navigationl1` varchar(255) NOT NULL default '',
				`navigationl2` varchar(255) NOT NULL default '',								
				`teasercontenttemplate` varchar(255) NOT NULL default '',
				`contenttemplate` varchar(255) NOT NULL default '',
				`printtemplate` varchar(255) NOT NULL default '',
				`specialtemplate` varchar(255) NOT NULL default '',
				`inlineedit` int(11) NOT NULL default '0',	
				`smartycache` int(11) NOT NULL default '0',		
				`backendlanguage` varchar(255) NOT NULL default '',
				`frontendlanguage` varchar(255) NOT NULL default '',
 				PRIMARY KEY  (`id`)
				) TYPE=MyISAM";
				
$table[]= "INSERT INTO `$cn_config` 
			(
				`id`,
				`startpageid`,
				`teasercontentpageid`,
				`sitetitle`,
				`mastertemplate`,
				`navigationl1`,
				`navigationl2`,
				`teasercontenttemplate`,
				`contenttemplate`,
				`printtemplate`,
				`specialtemplate`,
				`pageimagetemplate`,
				`pagefootertemplate`,
				`pageheadertemplate`,
				`inlineedit`,
				`globalpageimage`,
				`globalsyskey`,
				`backendlanguage`,
				`frontendlanguage`
			) 
				VALUES 
			(
				'0',
				'2',
				'2',
				'contentNow',
				'upload_admin/templates/page.html',
				'upload_admin/templates/navigation_l1.html',
				'upload_admin/templates/navigation_l2.html',
				'upload_admin/templates/teaser.html',
				'upload_admin/templates/content.html',
				'upload_admin/templates/page_print.html',
				'upload_admin/templates/page_text.html',
				'upload_admin/templates/pageimage.html',
				'upload_admin/templates/footer.html',
				'upload_admin/templates/header.html',
				'0',
				'image/header.jpg',
				'0',
				'en',
				'default'
			);";

$table[]= "DROP TABLE IF EXISTS `$cn_content`;";
$table[]= "CREATE TABLE IF NOT EXISTS `$cn_content` (
				`id` int(11) NOT NULL auto_increment,
				`pid` int(11) NOT NULL default '0',
				`sort` int(11) NOT NULL default '0',
				`hidden` int(11) NOT NULL default '0',
				`tstamp` int(11) NOT NULL default '0',
				`starttime` int(11) NOT NULL default '0',
				`endtime` int(11) NOT NULL default '0',
				`deleted` int(11) NOT NULL default '0',
				`contenttype` int(11) NOT NULL default '0',
				`contentsyskey` varchar(255) NOT NULL default '',
				`contenttitle` varchar(255) NOT NULL default '',
				`contentsubtitle` varchar(255) NOT NULL default '',
				`contenturl` varchar(255) NOT NULL default '',
				`content` text NOT NULL,
				PRIMARY KEY  (`id`)
				) TYPE=MyISAM";

$table[]= "DROP TABLE IF EXISTS `$cn_sections`;";
$table[]= "CREATE TABLE IF NOT EXISTS `$cn_sections` (
				`pageid` int(11) NOT NULL default '0',
				`pageleft` int(11) NOT NULL default '0',
				`pageright` int(11) NOT NULL default '0',
				`pagelevel` int(11) default NULL default '0',
				`pagename` varchar(255) NOT NULL default '',
				`pageimage` varchar(255) NOT NULL default '',  
				`template` varchar(255) NOT NULL default '',
				`mtemplate` varchar(255) NOT NULL default '',
				`description` varchar(255) NOT NULL default '',
				`syskey` varchar(255) NOT NULL default '',
				`pagetype` int(11) NOT NULL default '0',
				`pageurl` varchar(255) NOT NULL default '',
				PRIMARY KEY  (`pageid`)
				) TYPE=MyISAM";
$table[]= "INSERT INTO `$cn_sections` VALUES (1, 1, 4, 0, 'ContentNow', '', '', '', '', '', 0, '');";
$table[]= "INSERT INTO `$cn_sections` VALUES (2, 2, 3, 1, 'Home', '', '', '', '', '', 0, '');";

$table[]= "DROP TABLE IF EXISTS `$cn_sections_seq`;";
$table[]= "CREATE TABLE IF NOT EXISTS `$cn_sections_seq` (
				`id` int(11) NOT NULL default '0',
				PRIMARY KEY  (`id`)
				) TYPE=MyISAM;";
$table[]= "INSERT INTO `$cn_sections_seq` (`id`) VALUES ('3');";

$table[]= "DROP TABLE IF EXISTS `$cn_modul`;";
$table[]= "CREATE TABLE IF NOT EXISTS `$cn_modul` (
			  `id` int(11) NOT NULL auto_increment,
			  `name` varchar(255) NOT NULL default '',
			  `url` varchar(255) NOT NULL default '',
			  `version` varchar(255) NOT NULL default '',
			  `author` varchar(255) NOT NULL default '',			  			  
			  `config` text NOT NULL,
			  `param` text NOT NULL,
			  `label` text NOT NULL,
			  `paramvalue` text NOT NULL,			  
			  `deleted` int(11) NOT NULL default '0',
			  PRIMARY KEY  (`id`)
			) TYPE=MyISAM";

$table[]= "DROP TABLE IF EXISTS `$cn_sessions`;";
$table[]= "CREATE TABLE IF NOT EXISTS `$cn_sessions` (
			  `id` int(11) NOT NULL auto_increment,
			  `sid` varchar(255) NOT NULL default '',
			  `user` varchar(255) NOT NULL default '',
			  `password` varchar(255) NOT NULL default '',
			  `name` varchar(255) NOT NULL default '',
			  `email` varchar(255) NOT NULL default '',
			  `group` int(11) NOT NULL default '0',
			  `timestamp` int(15) NOT NULL default '0',
			  `ip` varchar(255) NOT NULL default '',
			  `pid` int(11) NOT NULL default '1',
			  `mode` varchar(255) NOT NULL default '',
			  `backendlanguage` varchar(255) NOT NULL default '',
			  `contentlanguage` varchar(255) NOT NULL default '',
			  PRIMARY KEY  (`id`)
				) TYPE=MyISAM";
$table[]= "INSERT INTO `$cn_sessions` VALUES (1, 0, '$cn_adminuser', '".md5($cn_adminpass)."', '$cn_adminname','$cn_adminemail',0, 0, 0, 1, 'content','en','');";

switch ($_POST['installStep']) {

	default :
		if ($_POST['login'] != '' && md5($_POST['login']) == '54c84b40e9ff5a31472904a0cd2f0a17') {
			$installStep= 1;
			$installHeadline= 'Welcome';
			$installMsg= '<p>Welcome to the install tool of contentNow.</p><p>Please start installation by clicking the button.</p>';
			$installSubmit= '<input type="submit" class="submit_120" name="installSubmit" value="Start Install">';
		} else {
			$installStep= 0;
			$installHeadline= 'Installation Login';
			$installMsg= '<input type="password" name="login" id="installpassword" class="width_120" value="">&nbsp;&nbsp;Please enter install password';
			$installSubmit= '<input type="submit" class="submit_120" name="installSubmit" value="Login"><script type="text/javascript">window.onload = document.getElementById(\'installpassword\').focus();</script>';
		}
		break;

	case "1" :
		$installStep= 2;
		$installHeadline= 'Installation Step 1';
		$installMsg='<p><strong>Step 1: Create admin user</strong></p>
					<p>Step 2: Create MySQL tables</p>
					<p>Step 3: Checking writable directories</p>
					<p>Step 4: Finish installation</p>
					<p style="margin:20px;"><strong style="color:red;">WARNING! PLEASE BACKUP YOUR DATABASE! ALL EXISTING DATA WILL BE OVERWRITTEN</strong></p>';					
		$installSubmit= '
		<p style="clear:both;"><strong>Create new admin user</strong></p>
		<p style="clear:both;">&nbsp;</p>
		<ul>
			<li style="float:left;width:100px;">Username:</li>
			<li style="float:left;width:200px;"><input type="text" class="width_120" name="adminuser" value="" /></li>
			<li style="float:left;width:100px;">Password:</li> 
			<li style="float:left;width:200px;"><input type="password" class="width_120" name="adminpassword" value="" /></li>
		</ul>
		<p style="clear:both;">&nbsp;</p>
		<ul>
			<li style="float:left;width:100px;">Adminname:</li> 
			<li style="float:left;width:200px;"><input type="text" class="width_120" name="adminname" value="" /></li>
			<li style="float:left;width:100px;">Adminemail:</li>
			<li style="float:left;width:200px;"><input type="text" class="width_120" name="adminemail" value="" /></li>
		</ul>
		<p style="clear:both;padding-top:20px;"><strong>Configure Database</strong></p>
		<p style="clear:both;">&nbsp;</p>
		<ul>
			<li style="float:left;width:100px;">DB user:</li>
			<li style="float:left;width:200px;"><input type="text" class="width_120" name="dbuser" value="" /></li>
			<li style="float:left;width:100px;">DB name:</li> 
			<li style="float:left;width:200px;"><input type="text" class="width_120" name="dbname" value="" /></li>
		</ul>
		<p style="clear:both;">&nbsp;</p>
		<ul>
			<li style="float:left;width:100px;">DB password:</li> 
			<li style="float:left;width:200px;"><input type="text" class="width_120" name="dbpassword" value="" /></li>
			<li style="float:left;width:100px;">DB host:</li>
			<li style="float:left;width:200px;"><input type="text" class="width_120" name="dbhost" value="" /></li>
		</ul>
		<p style="clear:both;">&nbsp;</p>
		<ul>
			<li><input type="submit" class="submit_120" name="installSubmit" value="Create" /></li>
		</ul>
		<p style="clear:both;">&nbsp;</p>';
		break;

	case "2" :
		$check = true;
		
		// check input fields
		$checkPostVar = array ('adminuser','adminpassword','adminname','adminemail','dbname', 'dbhost');
		foreach ($checkPostVar as $key) {
			if (!$_POST[$key]) {
				$check = false;
				break;
			}
		}

		// check db connection		
		if ( $check == true ) {
			$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
			$cnDatabase->Connect($cn_dbhost, $cn_dbuser, $cn_dbpassword, $cn_dbname);
			// check connection
			$dbErrorMsg =$cnDatabase->ErrorMsg();
			if ($dbErrorMsg!='') $check= false;
		}
		
		// make install
		if ( $check == true ) {
		
			$installStep= 3;
			
			foreach ($table as $id => $value) {
			$res = $cnDatabase->Execute($value);
				if ($res == false) die ('<span style="font:13px sans-serif;">Table creation failed. Check your database configuration.<br><br>'.$value.'<br><br>'.mysql_error().'</span>');
			}

			$encKey = microtime();
			$encKey = str_replace(" ", "_", $encKey);
			$encKey = str_replace(".", "_", $encKey);
			
			// Modify configure.php
			$localConfContent.= "\n";
			$localConfContent.= "define('CN_DB_USER','$cn_dbuser');\n";
			$localConfContent.= "define('CN_DB_NAME','$cn_dbname');\n";
			$localConfContent.= "define('CN_DB_PASSWORD','$cn_dbpassword');\n";
			$localConfContent.= "define('CN_DB_HOST','$cn_dbhost');\n";
			$localConfContent.= "define('CN_VERSION_FOR_UPDATE','".CN_VERSION."');\n";
			$localConfContent.= "define('CN_ENC_KEY','".$encKey."');\n";			
			$localConfContent.= "?>\n";
			
			// read old file
			$handle = fopen ($confLocalFile, "r");
			$contents = fread ($handle, filesize ($confLocalFile));
			fclose ($handle);
			$contents = str_replace("?>", "// Modified by install tool", $contents);
			
			if (!$handle = fopen($confFile, "w+")) die ('<span style="font:13px sans-serif;">Unable to locate local config.</span>');
			if (!fwrite($handle, $contents.$localConfContent)) die ('<span style="font:13px sans-serif;">Unable to write local config.</span>');
				
			$installHeadline= 'Installation Step 2';
			$installMsg='<p><strong>Step 1: Create admin user | done</strong></p>
						<p><strong>Step 2: Create MySQL tables | done</strong></p>
						<p>Step 3: Checking writable directories</p>
						<p>Step 4: Finish installation</p>';
						
			$installSubmit= '<input type="submit" class="submit_120" name="installSubmit" value="Next">';
		} else {
			$installStep= 2;
			$installHeadline= 'Installation Step 1';
			$installMsg='<p><strong>Step 1: Create admin user</strong></p>
						<p>Step 2: Create MySQL tables</p>
						<p>Step 3: Checking writable directories</p>
						<p>Step 4: Finish installation</p>
						<p style="margin:20px;"><strong style="color:red;">WARNING! PLEASE BACKUP YOUR DATABASE! ALL EXISTING DATA WILL BE OVERWRITTEN</strong></p>';					
			if ($cn_adminpass==CN_ADMIN_PASS) $passOut = ' ('.CN_ADMIN_PASS.')';
			$installSubmit= '
			<p style="clear:both;"><strong>Create new admin user</strong></p>
			<p style="clear:both;">&nbsp;</p>
			<ul>
				<li style="float:left;width:100px;">Username:</li>
				<li style="float:left;width:200px;"><input type="text" class="width_120" name="adminuser" value="'.$cn_adminuser.'"></li>
				<li style="float:left;width:100px;">Password:</li> 
				<li style="float:left;width:200px;"><input type="password" class="width_120" name="adminpassword" value="'.$cn_adminpass.'"> '.$passOut.'</li>
			</ul>
			<p style="clear:both;">&nbsp;</p>
			<ul>
				<li style="float:left;width:100px;">Adminname:</li> 
				<li style="float:left;width:200px;"><input type="text" class="width_120" name="adminname" value="'.$cn_adminname.'"></li>
				<li style="float:left;width:100px;">Adminemail:</li>
				<li style="float:left;width:200px;"><input type="text" class="width_120" name="adminemail" value="'.$cn_adminemail.'"></li>
			</ul>
			<p style="clear:both;padding-top:20px;"><strong>Configure Database</strong></p>
			<p style="clear:both;">&nbsp;</p>
			<ul>
				<li style="float:left;width:100px;">DB user:</li>
				<li style="float:left;width:200px;"><input type="text" class="width_120" name="dbuser" value="'.$cn_dbuser.'"></li>
				<li style="float:left;width:100px;">DB name:</li> 
				<li style="float:left;width:200px;"><input type="text" class="width_120" name="dbname" value="'.$cn_dbname.'"></li>
			</ul>
			<p style="clear:both;">&nbsp;</p>
			<ul>
				<li style="float:left;width:100px;">DB password:</li> 
				<li style="float:left;width:200px;"><input type="text" class="width_120" name="dbpassword" value="'.$cn_dbpassword.'"></li>
				<li style="float:left;width:100px;">DB host:</li>
				<li style="float:left;width:200px;"><input type="text" class="width_120" name="dbhost" value="'.$cn_dbhost.'"></li>
			</ul>
			<p style="clear:both;">&nbsp;</p>
			<ul>
				<li><span style="color:red;">Please fill in required fields: Username, Password, Adminname, Adminemail, DB name, DB host.<br />'.$dbErrorMsg.'</span><br />
					<input type="submit" class="submit_120" name="installSubmit" value="Create"></li>
			</ul>
			<p style="clear:both;">&nbsp;</p>';					
		}
		break;

	case "3" :
		$installHeadline= 'Installation Step 3';

		$filename[]= 'cn/smarty/templates_c';
		$filename[]= 'cn/smarty/templates_cn';
		$filename[]= 'cn/smarty/cache';
		$filename[]= 'upload';
		$filename[]= 'upload_c';
		$filename[]= 'upload/file';
		$filename[]= 'upload/flash';
		$filename[]= 'upload/image';
		$filename[]= 'upload/upload_admin';
		$filename[]= 'cn/constants.php';

		$filenameNotWritable= array ();
		$filenameWritable= array ();

		foreach ($filename as $value) {
			if (is_writable($rootDir.$value)) {
				$filenameWritable[]= $value;
			} else {
				$filenameNotWritable[]= $value;
			}
		}

		if (count($filenameNotWritable) == 0) {
			$installStep= 4;
			$installMsg='<p><p><strong>Step 1: Create admin user | done</strong></p>
						<p><strong>Step 2: Create MySQL tables | done</strong></p>
						<p><strong>Step 3: Checking writable directories | done</strong></p>
						<p>Step 4: Finish installation</p>';
			$installSubmit= '<input type="submit" class="submit_120" name="installSubmit" value="Next">';
		} else {
			$folder_writable= '';
			$folder_not_writable= '';
			foreach ($filenameWritable as $value) {
				$folder_writable .= $value.' (ok)<br>';
			}
			foreach ($filenameNotWritable as $value) {
				$folder_not_writable .= $value.' (folder not writable)<br>';
			}
			$installStep= 3;
			$installMsg='<p><strong>Step 1: Create admin user | done</strong></p>
						<p><strong>Step 2: Create MySQL tables | done</strong></p>
						<p><strong>Step 3: Checking writable directories</strong></p>
						<p style="margin: 10px;"></p>
						'.$folder_writable.'
						<p style="margin: 10px;"></p>
						<hr>
						<p style="margin: 10px;"></p>
						'.$folder_not_writable.'
						<p style="margin: 10px;"></p>
						<p>Step 4: Finish installation</p>';
			$installSubmit= '<input type="submit" class="submit_120" name="installSubmit" value="Check again">';
		}
		break;

	case "4" :
		
		if (file_exists($destPath) && !@unlink($destPath)) die ('<span style="font:13px sans-serif;">Unable to delete local config.</span>');
		if (!@copy($confFile, $destPath)) die ('<span style="font:13px sans-serif;">Unable to move local config.</span>');
			
		$installHeadline= 'Installation Step 4';
		$installMsg='<p><strong>Step 1: Create admin user | done</strong></p>
					<p><strong>Step 2: Create MySQL tables | done</strong></p>
					<p><strong>Step 3: Checking writable directories | done</strong></p>
					<p><strong>Step 4: Finish installation | done</strong></p>';
		$installSubmit= '<input type="button" onclick="window.location.href=\'../index.php\'" class="submit_120" name="installSubmit" value="Login contentNow">';
		break;
}

echo '
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" lang="de_DE" xml:lang="de_DE">
<!--
 * ContentNow | Small Content Management System
 * File: install index.php
 * Created: 10.02.2006
 * (C) 2006 Andre Michaelis <kontakt(at)michaelis-freunde.de>
-->
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
	<title>ContentNow Install</title>
	<link href="../'.CN_SKINDIR.'style.css" rel="stylesheet" type="text/css" media="screen" />
	<!--[if IE]> <link href="../'.CN_SKINDIR.'style_ie.css" rel="stylesheet" type="text/css" media="all" /><![endif]-->
</head>
<body>
<form method="POST" action="'.$_SERVER['SELF'].'" name="cnInstall" id="cnInstall">
<input type="hidden" name="installStep" value="'.$installStep.'">
<div id="cn_topnav"><div id="cn_topnavinline"><div id="row">&nbsp;</div></div></div>
<div id="cn_login">
<p class="head">'.$installHeadline.'</p>
<ul>
	<li class="item">'.$installMsg.'</li>
  	<li class="item">'.$installSubmit.'</li>
   	 </ul>
   	 </div>
   	 </form>
</body>
</html>';

?>