<?php

/**
 *
 * ContentNow | Small Content Management System
 *
 * Copyright (C) 2005/2006 Andre Michaelis <kontakt@michaelis-freunde.de>
 *
 * This file may be distributed and/or modified under the terms of the
 * "GNU General Public License" version 2 as published by the Free
 * Software Foundation and appearing in the file LICENSE included in
 * the packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 *
 * The "GNU General Public License" (GPL) is available at
 * http://www.gnu.org/copyleft/gpl.html.
 *
 */

 class cnCore {

	var $pageid;
	var $mode;
	var $contentLanguage;
	var $contentLanguageSuffix;
	var $language;
	var $configArray;
	var $contentArray;
	var $teaserContentArray;
	var $navigationArray;
	var $pageleft;
	var $pageright;
	var $pagelevel;
	var $pagename;
	var $pageimage;
	var $template;
	var $mtemplate;
	var $description;
	var $syskey;
	var $pagetype;
	var $pageurl;

	/**
	 * function setBackendLanguage()
	 * @descr 	set backend language
	 * @param 	$setLang
	 * @return 	-
	 */

	function setBackendLanguage($setLang,$addPath='') {
		$cnLanguageArray = '';
		$setLang = $this->checkForSecureVar($setLang);
		global $CN_GLOBAL;
		if (!array_key_exists($setLang,$CN_GLOBAL['backend_language'])) die ('<span style="font:13px sans-serif;">Fatal error loading CMS. Please contact webmaster.</span>');
		include_once ($addPath.'./language/'.$setLang.'.language.php');
		$this->lang= $cnLanguageArray[$setLang];
		setlocale(LC_ALL, $this->lang['local_key']);
		return $cnLanguageArray[$setLang];
	}

	/**
	 * function setContentLanguage()
	 * @descr 	set frontend language
	 * @param 	$setContentLanguage
	 * @return 	-
	 */

	function setContentLanguage($setContentLanguage) {
		$this->contentLanguage = $setContentLanguage;
		$this->contentLanguageSuffix = empty($setContentLanguage) ? '' : '_'.$setContentLanguage;
	}

	function setId($id) {
		$this->pageid= $id;
	}
	function getId() {
		return $this->pageid;
	}
	function setMode($mode) {
		$this->mode= $mode;
	}
	function setConfigArray($array) {
		$this->configArray= $array;
	}
	function setNavigationArray($array) {
		$this->navigationArray= $array;
	}
	function setContentArray($array) {
		$this->contentArray= $array;
	}
	function setPageInfoArray($array) {
		$this->pageleft= $array['pageleft'];
		$this->pageright= $array['pageright'];
		$this->pagelevel= $array['pagelevel'];
		$this->pagename= $array['pagename'];
		$this->pageimage= $array['pageimage'];
		$this->template= $array['template'];
		$this->mtemplate= $array['mtemplate'];
		$this->description= $array['description'];
		$this->syskey= $array['syskey'];
		$this->pagetype= $array['pagetype'];
		$this->pageurl= $array['pageurl'];
	}

	/**
	 * function 	showTopNavigation()
	 * @descr	Show Head Navigation
	 * @param	-
	 * @return	string
	 */

	function showTopNavigation() {

		$rootID = $this->getRootPageID();

		if ($this->checkAccess('content'))
			$linkPageClass = ($this->mode == 'content' || $this->mode == 'meta' || $this->mode == 'list') ? 'active' : '';
			$linkPage= $this->makeCNLink($this->lang['link_page'], $_SERVER['PHP_SELF'], 'content', $rootID, $linkPageClass);

		if ($this->checkAccess('user'))
			if ($this->mode == 'user') {
				$linkUser= $this->makeCNLink($this->lang['link_user'], $_SERVER['PHP_SELF'], 'user', $rootID, 'active');
			} else {
				$linkUser= $this->makeCNLink($this->lang['link_user'], $_SERVER['PHP_SELF'], 'user', $rootID);
			}

		if ($this->checkAccess('modul'))
			if ($this->mode == 'modul') {
				$linkModul= $this->makeCNLink($this->lang['link_moduls'], $_SERVER['PHP_SELF'], 'modul', $rootID, 'active');
			} else {
				$linkModul= $this->makeCNLink($this->lang['link_moduls'], $_SERVER['PHP_SELF'], 'modul', $rootID);
			}

		if ($this->checkAccess('config'))
			if ($this->mode == 'config') {
				$linkConfig= $this->makeCNLink($this->lang['link_config'], $_SERVER['PHP_SELF'], 'config', $rootID, 'active');
			} else {
				$linkConfig= $this->makeCNLink($this->lang['link_config'], $_SERVER['PHP_SELF'], 'config', $rootID);
			}

		if ($this->checkAccess('filemanager'))
			$fileManager= '<a href="#" onmouseover="window.status=\'contentnow\';return true;" onclick="SC_show(\''.$this->lang['label_filemanager'].'\', \'./upload.php?path='.CN_UPLOAD_BASEDIR.'&type=upload&lang='.$this->lang['language_key'].'\', 400, 800)">'.$this->lang['link_filemanager'].'</a>';

		if ($this->checkAccess('preview'))
		$linkPreview = '<a href="#" onmouseover="window.status=\'contentnow\';return true;" onclick="this.blur();openPreviewWindow(\'../index.php?inline='.$this->configArray[0]['inlineedit'].'&pageid=\'+$(\'previewid\').value+\'&clang='.$this->contentLanguage.'\');" title="'.$this->lang['link_preview'].'">'.$this->lang['link_preview'].'</a>';

		$linkLogOut= $this->makeCNLink($this->lang['link_logout'].' '.strtoupper($_SESSION['user']), 'logout.php', $this->mode, $rootID);

		return '<div class="row"><div id="row_nav">'.$linkPage.$linkPreview.$fileManager.$linkUser.$linkConfig.$linkModul.$linkLogOut.'</div></div>';
	}

	/**
	 * function showContentNav()
	 * @descr	Show Content Navigation
	 * @param	-
	 * @return	string
	 */

	function showContentNav() {

		$liContentClass= $this->mode == 'content' ? ' class="active"' : '';
		$linkContent= '<a href="#" title="'.$this->lang['link_content'].'" onmouseover="window.status=\'contentnow\';return true;" onclick="this.blur();showContentItem(\''.$this->makeCNurl('./library/function.showitems.php','content').'\',\'cn_content\');">'.$this->lang['link_content'].'</a>';

		$liListClass= $this->mode == 'list' ? ' class="active"' : '';
		$linkContentList= '<a href="#" title="'.$this->lang['link_contentlist'].'" onmouseover="window.status=\'contentnow\';return true;" onclick="this.blur();showContentList(\''.$this->makeCNurl('./library/function.showlist.php','list').'\',\'\',\'cn_content\');">'.$this->lang['link_contentlist'].'</a>';

		$liMetaClass= $this->mode == 'meta' ? ' class="active"' : '';
		$linkMeta = '<a href="#" title="'.$this->lang['link_meta'].'" onmouseover="window.status=\'contentnow\';return true;" onclick="this.blur();showMeta(\''.$this->makeCNurl('./library/function.showmeta.php','meta').'\',\'cn_content\');">'.$this->lang['link_meta'].'</a>';

		$content = '<ul>';
		if ($this->checkAccess('meta'))
		$content .='<li'.$liMetaClass.'>'.$linkMeta.'</li>';
		if ($this->checkAccess('content'))
		$content .='<li '.$liContentClass.'>'.$linkContent.'</li>';
		if ($this->checkAccess('list'))
		$content .='<li '.$liListClass.'>'.$linkContentList.'</li>';

		$content .='<li class="end">&nbsp;</li></ul>';

		return $content;
	}

	/**
	 * function showNavigation()
	 * @descr	Show Navigation tree
	 * @param	-
	 * @return	string
	 */

	function showNavigation() {

		$content= '';
		$openNode= 1;
		global $CN_GLOBAL;

		foreach ($this->navigationArray as $id => $value) {

			// check open Node
			if ($value['pageid'] == $this->pageid) $openNode= $id;

			// dont add root node
			if ($id != 0) {
				// prepare
				$content .= 'd.add('.$id.',';
				$mode = $this->mode == 'list' ? 'meta' : $this->mode;
				$mode = 'content';
				// loop back to get node id
				for ($i= $id -1; $i >= 0; $i --) {
					if ($this->navigationArray[$i]['pagelevel'] == ($value['pagelevel'] - 1)) {
						$content .= $i.',\''.addslashes($this->encodeStr(substr($value['pagename'.$this->contentLanguageSuffix], 0, 30))).'\',\''.$this->makeCNurl('', $mode, $value['pageid']).'\',\'\',\'\',\''.$this->checkPageType($value['pagetype']).'\');
						';
						break;
					}
				}
			}
		}

		// display language in head
		$langHead = empty($this->contentLanguage) ? '' : ' ('.$CN_GLOBAL['content_language'][$this->contentLanguage].')';

		// return string
		return '
			<p class="head">'.$this->lang['label_menu'].$langHead.'</p>
			<div id="dtree_navigation">
			<script type="text/javascript" language="javascript">

					d = new dTree(\'d\');
					d.add(0,-1,\''.addslashes($this->encodeStr(substr($this->configArray[0]['sitetitle'], 0, 30))).'\',\''.$this->makeCNurl('', 'config', $this->getRootPageID() ).'\');
					'.$content.'
					document.write(d);
					d.openTo('.$openNode.', true);

			</script>
			</div>
			'.$this->contentLanguageDropDown('langid',$this->contentLanguage);


	}

	/**
	 * function showContent()
	 * @descr	Show Content Elements
	 * @param	$_GET['cid']
	 * 			main function handling content forms
	 * 			'edit'		edit single content
	 * 			'delete' 	delete single element
	 * 			'editnew'	edit new content element
	 * 			'new'		new content
	 * 			'modul'		new modul
	 * 			'default'	list elements
	 * @return	string
	 */

	function showContent() {

		// edit single content element
		if ($_GET['action'] == 'edit') {
			// get content
			$this->setContentArray(cnEngine :: getSingleContent($_GET['cid']));
			$content= '<ul id="editIcons">'.$this->getContentEditForm().'</ul>';
		}

		// edit new content element
		if ($_GET['action'] == 'editnew') {
			// get content
			$this->setContentArray(cnEngine :: getSingleContent($_GET['cid']));
			$content= '<ul id="editIcons">'.$this->getContentEditForm().'</ul>';
		}

		// new content element
		if ($_GET['action'] == 'new') {
			$content= '<ul id="editIcons">'.$this->getNewContentForm().'</ul>';
		}

		// new modul element
		if ($_GET['action'] == 'modul') {
			$content= '<ul id="editIcons">'.$this->getNewModulForm().'</ul>';
		}

		// delete single content element
		if ($_GET['action'] == 'delete') {
			$this->setDeleteItem($_GET['cid']);
			$this->setContentArray(cnEngine :: getActualContent());
			$content= '<ul id="categories">'.$this->getContentList('item').'</ul>
						<ul>'.$this->getContentListFooter().'</ul>';
		}

		// list items after paste action
		if ($_GET['action'] == 'pasteitem') {
			// action goes here
			$this->setpasteItem();
			unset ($_SESSION['singleContentArray']);
			$this->setContentArray(cnEngine :: getActualContent());
			$content= '<ul id="categories">'.$this->getContentList('item').'</ul>
						<ul>'.$this->getContentListFooter().'</ul>';
		}

		// default list
		if ($_GET['action'] == '') {
			$this->setContentArray(cnEngine :: getActualContent());
			$content= '<ul id="categories">'.$this->getContentList('item').'</ul>
						<ul>'.$this->getContentListFooter().'</ul>';
		}

		// add javascript sort items to non ajax sites
		if (substr($_SERVER['PHP_SELF'],-9,-4) == 'index') {
			$content.= '
			<script type="text/javascript" language="javascript">
			// <![CDATA[
					Sortable.create(\'categories\',{tag:\'li\',onUpdate:function(){populateSortVars()}});
			// ]]>
			</script>';
		}

		if ($_GET['cid']) $cidTitle = ' | CID '.$_GET['cid'];
		// return string
		return '
				<form method="post" name="formeditcontentitem" id="formeditcontentitem">
				<input type="hidden" id="contentLanguageSuffix" name="contentLanguageSuffix" value="'.$this->contentLanguageSuffix.'" />
				<input type="hidden" id="previewid" name="previewid" value="'.$this->pageid.'" />
				<p class="head_right">'.$this->lang['label_content'].' ('.$this->lang['label_id'].' '.$this->pageid.$cidTitle.')</p>
					'.$content.'
				</form>
				';
	}

	/**
	 * function showMeta()
	 * @descr	Show page metainformation
	 * @param	-
	 * @return	string
	 */

	function showMeta() {

		$tree = new tree();
		global $CN_GLOBAL;

		$splitContentLanguages = cnEngine::getContentLanguage();

		// make contenttitle for each language
		foreach ($splitContentLanguages as $value) {
			if ($value != 'default') {
				$boldPre = '';
				$boldSuf = '';
				// show active language in bold
				if ($value == $this->contentLanguage) {
					$boldPre = '<strong>';
					$boldSuf = '</strong>';
				}
				$alternativeLanguages .= '<li class="item_noborder">
											<div class="row_left"><div class="label_left">'.$boldPre.$this->lang['content_pagetitle'].' ('.$CN_GLOBAL['content_language'][$value].')'.$boldSuf.'</div><input type="text" name="section[pagename_'.$value.']" value="'.$this->encodeStr($this->getAlternativePagename($value)).'" class="width_600" /></div>
										</li>';
			}
		}

		if (!empty($alternativeLanguages)) {
			$boldPre = '';
			$boldSuf = ' (default)';
			if ($this->contentLanguage == '') {
				$boldPre = '<strong>';
				$boldSuf = ' (default)</strong>';
			}
		}

		$content= '<form method="post" action="'.$this->makePOSTLink().'" name="formEditSubmit" id="formEditSubmit">
							<input type="hidden" id="previewid" name="previewid" value="'.$this->pageid.'" />
							<p class="head_right">'.$this->lang['label_meta'].' ('.$this->encodeStr($this->pagename).' | '.$this->lang['label_id'].' '.$this->pageid.')</p>
							<ul>
							<li class="item_noborder">
								<div class="row_left"><div class="label_left">'.$boldPre.$this->lang['content_pagetitle'].$boldSuf.'</div><input type="text" id="section_pagename" name="section[pagename]" value="'.$this->encodeStr($this->pagename).'" class="width_600" /></div>
							</li>
							'.$alternativeLanguages.'
							<li class="item_noborder">
								<div class="row_left"><div class="label_left">'.$this->lang['content_template'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'section_template', 'file','single').'</div><input type="text" name="section[template]" id="section_template" class="pad_3" value="'.$this->template.'" />'.$this->makeInputClear('section_template').'</div>
								<div class="row_left"><div class="label_left">'.$this->lang['content_mtemplate'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'section_mtemplate', 'file','single').'</div><input type="text" name="section[mtemplate]" id="section_mtemplate" class="pad_3" value="'.$this->mtemplate.'" />'.$this->makeInputClear('section_mtemplate').'</div>
								<div class="row_left"><div class="label_left">'.$this->lang['content_image'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'section_pageimage', 'imageedit','single').'</div><input type="text" name="section[pageimage]" id="section_pageimage" class="pad_3" value="'.$this->pageimage.'" />'.$this->makeInputClear('section_pageimage').'</div>
								<div class="row_left"><div class="label_left">'.$this->lang['content_syskey'].'</div><input type="text" name="section[syskey]" id="section_syskey" class="pad_3" value="'.$this->encodeStr($this->syskey).'" />'.$this->makeInputClear('section_syskey').'</div>
								<div class="row_left"><div class="label_left">'.$this->lang['content_description'].'</div><input type="text" name="section[description]" id="section_description" class="pad_3" value="'.$this->encodeStr($this->description).'" />'.$this->makeInputClear('section_description').'</div>
								<div class="row_left"><div class="label_left">'.$this->lang['content_urlid'].' '.$this->makeUploadPopUp('', 'section_pageurl', 'getID','single').'</div><input type="text" name="section[pageurl]" id="section_pageurl" class="pad_3" value="'.$this->pageurl.'" />'.$this->makeInputClear('section_pageurl').'</div>
								<div class="row_clear"></div>
								<div class="row_left"><div class="label_left">'.$this->lang['content_pagetype'].'</div>'.$this->pagetypeDropDown($this->pagetype).'</div>
								<div class="row_left"><div class="label_left">'.$this->lang['content_move'].'</div><select name="target_section_id">';

		$addNewPageOptionMenu= '';
		$currentSection= $tree->GetNodeInfo($this->pageid);

		$tree->Full('');
		while ($item= $tree->NextRow()) {
			$selectValue= ($item['pageid'] == $this->pageid) ? 'selected' : '';
			$selectNameSpacing= str_repeat('&nbsp;', 2 * $item['pagelevel']);
			$selectNameSpacingWide= str_repeat('&nbsp;', 5 * $item['pagelevel']);
			$selectNameBefore= ($item['pageid'] == $this->pageid) ? '<strong>' : '';
			$selectNameAfter= ($item['pageid'] == $this->pageid) ? '</strong>' : '';
			if ($item['pageid'] == CN_IDROOT) {
				$item['pagename'.$this->contentLanguageSuffix] .= ' (Root)';
				// additinal button to generate new page in root node
				$addNewPageAdditionalButton = '<input type="button" title="'.$this->lang['meta_insert_page'].'" value="'.$this->lang['meta_insert_page'].'" class="submit_120" onclick="$(\'showaddnewpage\').value=1;$(\'new_target_section_id\').value='.$item['pageid'].';$(\'formEditSubmit\').submit();" />';
			}
				// for option (top)
				$content .= '
				<option value="'.$item['pageid'].'" '.$selectValue.' >'.$selectNameSpacing.$selectNameBefore.$this->encodeStr($item['pagename'.$this->contentLanguageSuffix]).$selectNameAfter.'</option>';

				// for add new page (bottom)
				$addNewPageOptionMenu .= '
				<ul>
					<li style="padding-bottom: 0px;padding-left: 100px;">'.$selectNameSpacingWide.$selectNameBefore.$this->encodeStr($item['pagename'.$this->contentLanguageSuffix]).$selectNameAfter.'</li>
					<li style="padding-bottom: 15px;">
						<small>'.$this->lang['meta_insert_page_after'].'</small>
						<a href="#" onclick="$(\'showaddnewpage\').value=1;$(\'new_target_section_id\').value='.$item['pageid'].';$(\'formEditSubmit\').submit();"><img src="'.CN_SKINIMAGE.'tool_addsite.gif" border="0"></a>
					</li>
				</ul>';
		}
		$content .= '</select></div>';

		if ($this->pageid != CN_IDROOT) {
			// Prepare the data for position method, assigns a node with all its children to another parent
			$currentSection= $tree->GetNodeInfo($this->pageid);
			$tree->Parents($this->pageid, array ('pageid'), array ('and' => array ('pagelevel = '. ($currentSection[2] - 1))));
			$item= $tree->NextRow();
			$tree->Branch($item['pageid'], array ('pageid'), array ('and' => array ('pagelevel = '.$currentSection[2])));

			while ($item= $tree->NextRow()) {
				$moveUpDownArray[]= $item['pageid'];
			}

			$arrayCount= 0;
			$endArray= count($moveUpDownArray);

			if ($endArray > 1) {
				$content .= '<div class="row_left"><div class="width_400">'.$this->lang['content_position'].'</div>
							<p style="margin: 5px;"></p>';
				$linkUp= '';
				$linkDown= '';
				foreach ($moveUpDownArray as $value) {
					$arrayCount ++;
					if ($value == $this->pageid && $arrayCount != 1) {
						$linkUp= '<input type="button" title="'.$this->lang['button_up'].'" value="'.$this->lang['button_up'].'"class="submit_120" onclick="changeUrl(\''.$this->makeCNurl(CN_BASEDIR.'/index.php','','','pageaction=moveup&position='.$moveUpDownArray[($arrayCount-2)]).'\');" />';
					}
					if ($value == $this->pageid && $arrayCount != $endArray) {
						$linkDown= '<input type="button" title="'.$this->lang['button_down'].'" value="'.$this->lang['button_down'].'" class="submit_120" onclick="changeUrl(\''.$this->makeCNurl(CN_BASEDIR.'/index.php','','','pageaction=movedown&position='.$moveUpDownArray[($arrayCount)]).'\');" />';
					}
				}
				$linkPipe= ((!empty ($linkUp) && empty ($linkDown)) || (empty ($linkUp) && !empty ($linkDown))) ? '' : '&nbsp;&nbsp;';
				$content .= $linkUp.$linkPipe.$linkDown.'</div>';
			}
		}
		$content .= '<div class="row_clear"></div>
					</li>';

		// check last site in tree
		$deleteButton= ($this->pagelevel == 0 || ( $this->pagelevel == 1 && $endArray <= 1 )) ?
			''
			:
			'<input type="hidden" id="setdeletepage" name="setdeletepage" value="" />
			<input type="button" title="'.$this->lang['button_deletepage'].'" value="'.$this->lang['button_deletepage'].'" onclick="if(confirm(\''.$this->lang['content_confirmdelete'].'\')==true){$(\'setdeletepage\').value=1;this.form.submit();}" class="submit_120" />
			';

		$content .= '<li class="item_footer" id="showmetabutton">
												<div class="row_right_clear">
													<input type="hidden" id="setsavepage" name="setsavepage" value="" />
													<input type="hidden" id="duplicatepage" name="duplicatepage" value="" />
													<input type="button" title="'.$this->lang['button_save'].'" value="'.$this->lang['button_save'].'" onclick="$(\'setsavepage\').value=1;Element.show(\'cn_pagemessage\');this.form.submit();" class="submit_120" />
													<input type="button" title="'.$this->lang['button_duplicatepage'].'" value="'.$this->lang['button_duplicatepage'].'" onclick="$(\'duplicatepage\').value=1;Element.show(\'cn_pagemessage\');this.form.submit();" class="submit_120" />
													'.$deleteButton.$addNewPageAdditionalButton.'
												</div>
											</li>
										</ul>
							</ul>
							<p class="head_right" style="border-top: none;">'.$this->lang['label_addpage'].'</p>
							<ul>
								<li class="item_noborder">
								<div class="row_right_clear">'.$this->makeToggleLink('addpage', ' <strong>'.$this->lang['meta_new_page_after'].'</strong>').'
									<div id="addpage" style="display:none;">
										<p style="margin: 10px;"></p>
										<input type="hidden" id="new_target_section_id" name="new_target_section_id" value="" />
										<input type="hidden" id="showaddnewpage" name="showaddnewpage" value="" />
										'.$addNewPageOptionMenu.'
										<p style="padding-top: 10px;clear:left;"></p>
									</div>
								</div>
								</div>
								</li>
							</ul>
						</form>
					';
		$content .= $this->setJavaFocus('section_pagename');

		return $content;
	}

	/**
	 * function showMetaAddNewPage()
	 * @descr	Show formular new page metainformation
	 * @param	-
	 * @return	string
	 */

	function showMetaAddNewPage() {
		global $CN_GLOBAL;
		$splitContentLanguages = cnEngine::getContentLanguage();

		foreach ($splitContentLanguages as $value) {
			if ($value != 'default') {
			$alternativeLanguages .= '<li class="item_noborder">
										<div class="row_left">
											<div class="label_left">'.$this->lang['content_pagetitle'].' ('.$CN_GLOBAL['content_language'][$value].')</div>
											<input type="text" id="section[pagename_'.$value.']" name="section[pagename_'.$value.']" value="" class="width_600" />
										</div>
									</li>';
			$checkAlternativeTitle .= '
					if($(\'section[pagename_'.$value.']\').value==\'\'){$(\'section[pagename_'.$value.']\').focus();returnVar=false;}';
			}
		}

		$content= '
				<script type="text/javascript" language="javascript">
				// <![CDATA[
				function chkFormular() {
					var returnVar = true;
					'.$checkAlternativeTitle.'
					if($(\'section[pagename]\').value==\'\'){$(\'section[pagename]\').focus();returnVar=false;}
					if (returnVar == false) alert(\''.$this->lang['confirm_empty'].'\');
					return returnVar;
				}
				// ]]>
				</script>
					<form method="post" action="'.$this->makePOSTLink().'" name="formAddSubmit" id="formAddSubmit">
							<input type="hidden" id="previewid" name="previewid" value="'.$this->pageid.'" />
							<input type="hidden" name="new_target_section_id" value="'.$_POST['new_target_section_id'].'" />
							<p class="head_right">'.$this->lang['label_addpage'].' ('.$this->lang['label_after'].' '.$this->lang['label_page'].' '.$this->lang['label_id'].' '.$_POST['new_target_section_id'].')</p>
							<ul>
								<li class="item_noborder">
									<div class="row_left"><div class="label_left">'.$this->lang['content_pagetitle'].'</div><input type="text" id="section[pagename]" name="section[pagename]" value="" class="width_600" /></div>
								</li>
								'.$alternativeLanguages.'
								<li class="item_noborder">
									<div class="row_left"><div class="label_left">'.$this->lang['content_template'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'section_template', 'file','single').'</div><input type="text" name="section[template]" id="section_template" value="" class="pad_3" />'.$this->makeInputClear('section_template').'</div>
									<div class="row_left"><div class="label_left">'.$this->lang['content_mtemplate'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'section_mtemplate', 'file','single').'</div><input type="text" name="section[mtemplate]" id="section_mtemplate" value="" class="pad_3" />'.$this->makeInputClear('section_mtemplate').'</div>
									<div class="row_left"><div class="label_left">'.$this->lang['content_image'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'section_pageimage', 'imageedit','single').'</div><input type="text" name="section[pageimage]" id="section_pageimage" value="" class="pad_3" />'.$this->makeInputClear('section_pageimage').'</div>
									<div class="row_left"><div class="label_left">'.$this->lang['content_syskey'].'</div><input type="text" name="section[syskey]" id="section_syskey" value="" class="pad_3" />'.$this->makeInputClear('section_syskey').'</div>
									<div class="row_left"><div class="label_left">'.$this->lang['content_description'].'</div><input type="text" name="section[description]" id="section_description" value="" class="pad_3" />'.$this->makeInputClear('section_description').'</div>
									<div class="row_left"><div class="label_left">'.$this->lang['content_urlid'].' '.$this->makeUploadPopUp('', 'section_pageurl', 'getID','single').'</div><input type="text" name="section[pageurl]" id="section_pageurl" class="pad_3" value="" />'.$this->makeInputClear('section_pageurl').'</div>
									<div class="row_left"><div class="label_left">'.$this->lang['content_pagetype'].'</div>'.$this->pagetypeDropDown(0).'</div>
									<div class="row_clear"></div>
								</li>
								<li class="item_footer">
									<div class="row_right_clear">
										<input type="hidden" id="setsavenewpage" name="setsavenewpage" value="" />
										<input type="button" title="'.$this->lang['button_save'].'" value="'.$this->lang['button_save'].'" onclick="if(chkFormular()==true){$(\'setsavenewpage\').value=1;this.form.submit();}" class="submit_120" />
										<input type="button" title="'.$this->lang['button_cancel'].'" value="'.$this->lang['button_cancel'].'" onclick="changeUrl(\''.$this->makePOSTLink().'\');" class="submit_120" />
									</div>
								</li>
							</form>';
		$content .= $this->setJavaFocus('section[pagename]');

		return $content;
	}

	/**
	 * function showConfig()
	 * @descr	Show page config
	 * @param	-
	 * @return	string
	 */

	function showConfig($errorMsg='') {

		// display language in head
		global $CN_GLOBAL;
		$langHead = empty($this->contentLanguage) ? '' : ' ('.$CN_GLOBAL['content_language'][$this->contentLanguage].')';

		$content = '<p class="head_right">'.$this->lang['label_config'].$langHead.'</p>
			<form method="post" action="'.$this->makePOSTLink('config','true').'" name="formeditconfig" id="formeditconfig">
			<input type="hidden" id="previewid" name="previewid" value="'.$this->pageid.'" />
			<input type="hidden" name="contentLanguageSuffix" id="contentLanguageSuffix" value="'.$this->contentLanguageSuffix.'" />
				<ul>';
		if (!empty($errorMsg)) $content .= '<li class="item">
											<div class="row_noborder"><span style="color: red;">'.$this->lang[$errorMsg].'</span></div>
										</li>';
		if ($this->checkAccess('config_templateconfiguration'))
		$content .= '<li class="item">
						<div class="row_noborder">'.$this->makeToggleLink('show1', ' <strong>'.$this->lang['config_templateconfiguration'].'</strong>').'</div>
						<div id="show1" style="display:none;">
							<div class="row_clear">&nbsp;</div>
							<div class="row_left_wide"><div class="label_left">'.$this->lang['config_master'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'mastertemplate', 'file','single').'</div><input type="text" class="pad_3" id="mastertemplate" name="config[mastertemplate]" value="'.$this->configArray[0]['mastertemplate'].'" />'.$this->makeInputClear('mastertemplate').'</div>
							<div class="row_left_wide"><div class="label_left">'.$this->lang['config_content'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'contenttemplate', 'file','single').'</div><input type="text" class="pad_3" id="contenttemplate" name="config[contenttemplate]" value="'.$this->configArray[0]['contenttemplate'].'" />'.$this->makeInputClear('contenttemplate').'</div>
							<div class="row_left_wide"><div class="label_left">'.$this->lang['config_navigation_l1'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'navigationl1', 'file','single').'</div><input type="text" class="pad_3" id="navigationl1" name="config[navigationl1]" value="'.$this->configArray[0]['navigationl1'].'" />'.$this->makeInputClear('navigationl1').'</div>
							<div class="row_left_wide"><div class="label_left">'.$this->lang['config_navigation_l2'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'navigationl2', 'file','single').'</div><input type="text" class="pad_3" id="navigationl2" name="config[navigationl2]" value="'.$this->configArray[0]['navigationl2'].'" />'.$this->makeInputClear('navigationl2').'</div>
							<div class="row_left_wide"><div class="label_left">'.$this->lang['config_contentteaser'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'teasercontenttemplate', 'file','single').'</div><input type="text" class="pad_3" id="teasercontenttemplate" name="config[teasercontenttemplate]" value="'.$this->configArray[0]['teasercontenttemplate'].'" />'.$this->makeInputClear('teasercontenttemplate').'</div>
							<div class="row_left_wide"><div class="label_left">'.$this->lang['config_print'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'printtemplate', 'file','single').'</div><input type="text" class="pad_3" id="printtemplate" name="config[printtemplate]" value="'.$this->configArray[0]['printtemplate'].'" />'.$this->makeInputClear('printtemplate').'</div>
							<div class="row_left_wide"><div class="label_left">'.$this->lang['config_special'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'specialtemplate', 'file','single').'</div><input type="text" class="pad_3" id="specialtemplate" name="config[specialtemplate]" value="'.$this->configArray[0]['specialtemplate'].'" />'.$this->makeInputClear('specialtemplate').'</div>
							<div class="row_left_wide"><div class="label_left">'.$this->lang['config_pageimagetemplate'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'pageimagetemplate', 'file','single').'</div><input type="text" class="pad_3" id="pageimagetemplate" name="config[pageimagetemplate]" value="'.$this->configArray[0]['pageimagetemplate'].'" />'.$this->makeInputClear('pageimagetemplate').'</div>
							<div class="row_left_wide"><div class="label_left">'.$this->lang['config_pageheadertemplate'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'pageheadertemplate', 'file','single').'</div><input type="text" class="pad_3" id="pageheadertemplate" name="config[pageheadertemplate]" value="'.$this->configArray[0]['pageheadertemplate'].'" />'.$this->makeInputClear('pageheadertemplate').'</div>
							<div class="row_left_wide"><div class="label_left">'.$this->lang['config_pagefootertemplate'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'pagefootertemplate', 'file','single').'</div><input type="text" class="pad_3" id="pagefootertemplate" name="config[pagefootertemplate]" value="'.$this->configArray[0]['pagefootertemplate'].'" />'.$this->makeInputClear('pagefootertemplate').'</div>
							<div class="row_clear"></div>
						</div>
					</li>';
		if ($this->checkAccess('config_localconfiguration'))
		$content .= '<li class="item">
						<div class="row_noborder">'.$this->makeToggleLink('show2',' <strong>'.$this->lang['config_localconfiguration'].'</strong>').'</div>
						<div id="show2" style="display:none;">
							<div class="row_clear">&nbsp;</div>
							<div class="row_left_wide"><div class="label_left">'.$this->lang['config_sitetitle'].'</div><input type="text" class="pad_3" id="sitetitle" name="config[sitetitle]" value="'.$this->encodeStr($this->configArray[0]['sitetitle']).'" />'.$this->makeInputClear('sitetitle').'</div>
							<div class="row_left_wide"><div class="label_left">'.$this->lang['config_startpid'].' '.$this->makeUploadPopUp('', 'startpageid', 'getID','single').'</div><input type="text" class="pad_3" id="startpageid" name="config[startpageid]" value="'.$this->configArray[0]['startpageid'].'" />'.$this->makeInputClear('startpageid').'</div>
							<div class="row_left_wide"><div class="label_left">'.$this->lang['config_teasercontentpid'].' '.$this->makeUploadPopUp('', 'teasercontentpageid', 'getID').'</div><input type="text" class="pad_3" id="teasercontentpageid" name="config[teasercontentpageid]" value="'.$this->configArray[0]['teasercontentpageid'].'" />'.$this->makeInputClear('teasercontentpageid').'</div>
							<div class="row_left_wide"><div class="label_left">'.$this->lang['config_syskey'].'</div><input type="text" class="pad_3" id="globalsyskey" name="config[globalsyskey]" value="'.$this->configArray[0]['globalsyskey'].'" />'.$this->makeInputClear('globalsyskey').'</div>
							<div class="row_left_wide"><div class="label_left">'.$this->lang['config_pageimage'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'globalpageimage', 'imageedit','single').'</div><input type="text" class="pad_3" id="globalpageimage" name="config[globalpageimage]" value="'.$this->configArray[0]['globalpageimage'].'" />'.$this->makeInputClear('globalpageimage').'</div>
							<div class="row_clear"></div>
						</div>
					</li>';
		if ($this->checkAccess('config_metaconfiguration')) {
			$content .= '<li class="item">
							<div class="row_noborder">'.$this->makeToggleLink('show3',' <strong>'.$this->lang['config_metaconfiguration'].'</strong>').'</div>
								<div id="show3" style="display:none;">
									<div class="row_clear">&nbsp;</div>';
			if ($this->checkAccess('config_metaconfiguration_copyright'))
			$content .= '<div class="row_left_wide"><div class="label_left">'.$this->lang['config_metainfo'].'</div><textarea style="height: 5em;" name="config[metainfo]">'.$this->encodeStr($this->configArray[0]['metainfo']).'</textarea></div>';
			if ($this->checkAccess('config_metaconfiguration_description'))
			$content .= '<div class="row_left_wide"><div class="label_left">'.$this->lang['config_metadescription'].'</div><textarea style="height: 5em;" name="config[metadescription]">'.$this->encodeStr($this->configArray[0]['metadescription']).'</textarea></div>';
			if ($this->checkAccess('config_metaconfiguration_keywords'))
			$content .= '<div class="row_left_wide"><div class="label_left">'.$this->lang['config_metakeywords'].'</div><textarea style="height: 5em;" name="config[metakeywords]">'.$this->encodeStr($this->configArray[0]['metakeywords']).'</textarea></div>';
			$content .= '<div class="row_clear"></div>
									</div>
								</li>';
		}
		if ($this->checkAccess('config_functions'))
		$content .= '<li class="item">
						<div class="row_noborder">'.$this->makeToggleLink('show4',' <strong>'.$this->lang['config_functions'].'</strong>').'</div>
						<div id="show4" style="display:none;">
							<div class="row_clear">&nbsp;</div>
							<div class="row_left_wide"><div class="label_left">'.$this->lang['config_backupMySQL'].'</div><input type="button" title="'.$this->lang['config_startbackupMySQL'].'" value="'.$this->lang['config_startbackupMySQL'].'" class="submit_120"  onclick="window.open(\'./library/function.backupdb.php\');" /></div>
							<div class="row_left_wide"><div class="label_left">'.$this->lang['config_remove_cache'].'</div>'.$this->makeCNAjaxLink($this->lang['config_start_remove_cache'],'./library/function.removecache.php','formeditconfig').'</div>
							<div class="row_left_wide"><div class="label_left">'.$this->lang['config_cleanupDB'].'</div>'.$this->makeCNAjaxLink($this->lang['config_startcleanupDB'],'./library/function.cleandb.php','formeditconfig').'</div>
							<div class="row_clear"></div>
						</div>
					</li>';
		if ($this->checkAccess('config_globalconfiguration'))
		$content .= '<li class="item">
						<div class="row_noborder">'.$this->makeToggleLink('show5',' <strong>'.$this->lang['config_globalconfiguration'].'</strong>').'</div>
						<div id="show5" style="display:none;">
							<div class="row_clear">&nbsp;</div>
							<div class="row_left_wide"><div class="label_left">'.$this->lang['config_change_backend_language'].'</div>'.$this->backendLanguageDropDown('config[backendlanguage]',$this->configArray[0]['backendlanguage']).'</div>
							<div class="row_left_wide"><div class="label_left">'.$this->lang['config_inline_edit'].'</div>'.$this->contentCheckBox('config[inlineedit]', $this->configArray[0]['inlineedit']).'</div>
							<div class="row_left_wide"><div class="label_left">'.$this->lang['config_smarty_cache'].'</div>'.$this->contentCheckBox('config[smartycache]', $this->configArray[0]['smartycache']).'</div>
							<div class="row_clear"></div>
						</div>
					</li>';
		if ($this->checkAccess('config_languages'))
		$content .= '<li class="item">
						<div class="row_noborder">'.$this->makeToggleLink('show6',' <strong>'.$this->lang['config_languages'].'</strong>').'</div>
						<div id="show6" style="display:none;">
							<div class="row_clear">&nbsp;</div>
							<div class="row_left_wide"><div class="label_left">'.$this->lang['config_new_website_language'].'</div>'.$this->frontendLanguageDropDown('newwebsitelangid').'&nbsp;
								<input type="hidden" name="newlanguage" id="newlanguage" value="" />
								<input type="button" title="'.$this->lang['config_install_language'].'" value="'.$this->lang['config_install_language'].'" class="submit_120" onclick="if(confirm(\''.$this->lang['config_confirm_install_language'].'\')==true){$(\'newlanguage\').value=1;this.form.submit();}" />
							</div>
							<div class="row_clear"></div>
						</div>
					</li>';
		if ($this->checkAccess('config_constants'))
		$content .= '<li class="item">
						<div class="row_noborder">'.$this->makeToggleLink('show7',' <strong>'.$this->lang['config_manage_constants'].'</strong>').'</div>
						<div id="show7" style="display:none;">
							<div class="row_clear">&nbsp;</div>
							<div class="row_no_border">
							<input type="button" title="'.$this->lang['config_constants_clickedit'].'" value="'.$this->lang['config_constants_clickedit'].'"id="constantsForm" class="submit_120" />
							<script type="text/javascript" language="javascript">
							// <![CDATA[
								new Ajax.InPlaceEditor($(\'constantsForm\'), \'./library/function.constants.php?action=save&lang='.$this->lang['language_key'].'\',
								    { callback: function(form, value) { return \'constants=\' + escape(value)},
									rows:15, cancelText:\''.$this->lang['button_cancel'].'\', okText:\''.$this->lang['button_save'].'\',
								    loadTextURL: \'./library/function.constants.php?action=load\'});
							// ]]>
							</script>
							</div>
							<div class="row_clear"></div>
						</div>
					</li>';
		if ($this->checkAccess('config_infocn'))
		$content .= '<li class="item">
						<div class="row_noborder"><strong>'.$this->lang['config_infocn'].'</strong></div>
						<div class="row_left_wide"><div class="label_left">'.$this->lang['config_infocopyright'].'</div><a href="http://www.contentnow.mf4k.de" target="_blank">www.contentnow.mf4k.de</a></div>
						<div class="row_left_wide"><div class="label_left">'.$this->lang['config_infoversion'].' '.CN_VERSION.'</div>&nbsp;</div>
						<div class="row_left_wide"><div class="label_left">SourceForge:</div><a href="http://sourceforge.net/projects/contentnow/" target="_blank"><img src="'.CN_SKINIMAGE.'sflogo-88x31.jpg" width="88" height="31" border="0" alt="SourceForge.net" /></a></div>
						<div class="row_clear"></div>
					</li>';

		$content .= '<li class="item_footer">
						<div class="row_right_clear">
							'.$this->makeCNAjaxLink($this->lang['button_save'],'./library/function.saveconfig.php','formeditconfig').
							$this->contentLanguageDropDown('langid',$this->contentLanguage,1).'
						</div>
					</li>
				</ul>
			</form>';
		return $content;
	}

	/**
	 * function showModulConfig()
	 * @descr	Show modul elements for install/deinstall
	 * @class	modul
	 * @param	-
	 * @return	string
	 */

	function showModul() {
		$this->getAllModuls();
		$cnModul= new cnModul();
		$content= '<form><input type="hidden" id="previewid" name="previewid" value="'.$this->pageid.'" /></form>
				  <p class="head_right">'.$this->lang['label_moduls'].'</p>'.$cnModul->getModulDir($this->allModulsArray,$this->lang);
		return $content;
	}

	/**
	 * function showUserForm()
	 * @descr	Show user form
	 * @param	-
	 * @return	string
	 */

	function showUser() {
		$content= '<form method="post" action="'.$this->makePOSTLink().'" name="newuseredit" id="newuseredit">
					<input type="hidden" id="previewid" name="previewid" value="'.$this->pageid.'" />
					<p class="head_right">'.$this->lang['user_label_management'].'</p>
					<ul>
							'.$this->getUserList().'
						</ul>';
		if (!$_POST['newuser']) {
			$content .= '<ul>
						<li class="item_footer">
							<div class="row_right_clear">
								<input type="hidden" id="newuser" name="newuser" value="" />
								<input type="button" title="'.$this->lang['user_newuser'].'" value="'.$this->lang['user_newuser'].'" class="submit_120" onclick="$(\'newuser\').value=1;this.form.submit();" />
							</div>
						</li>
						</ul>';
		}
		$content .= '</form>';
		return $content;
	}

	/**
	 * function getContentList()
	 * @descr	Show content elements
	 * @param	$showMode: list or item
	 * @return	string
	 */

	function getContentList($showMode='') {

	// mode = content or list
	switch ($showMode) {

		default:
		if (empty ($this->contentArray)) {
			// no items found
			$content= '<li class="item">'.$this->lang['content_noitems'].'</li>';
		} else {
			$content= '';
			// start loop
			foreach ($this->contentArray as $value) {

				switch ($value['contenttype']) {

					case "3" :
						// generate preview text for modul
						$_previewtext= explode('|*|', $value['content']);
						// array pos 1 -> modul name
						$_title = $this->encodeStr(empty($value['contenttitle']) ? $value['contentsubtitle'] : $value['contenttitle']);
						$_headline= '<strong>'.$this->lang['text_modul'].' '.$this->wordwrapStr($_previewtext[1]).'</strong>';
						$_content= '<span class="grey">'.$this->wordwrapStr(strip_tags($_title)).'</span>';
						break;

					case "2" :
						// generate preview php script
						$_title = $this->encodeStr(empty($value['contenttitle']) ? $value['contentsubtitle'] : $value['contenttitle']);
						$_headline= '<strong>'.$this->lang['text_contenturl'].' '.$this->wordwrapStr(strip_tags($_title)).'</strong>';
						$_content= '<span class="grey">'.$this->wordwrapStr(strip_tags($this->lang['content_url'].' '.$value['contenturl'])).'</span>';
						break;

					case "1" :
						// generate preview text for teaser content
						$_title = $this->encodeStr(empty($value['contenttitle']) ? $value['contentsubtitle'] : $value['contenttitle']);
						$_headline= '<strong>'.$this->lang['text_teasercontent'].' '.$this->wordwrapStr(strip_tags($_title)).'</strong>';
						$_content= '<span class="grey">'.$this->wordwrapStr(strip_tags($value['content'])).'</span>';
						break;

					default :
						// generate preview text for text element
						$_title = $this->encodeStr(empty($value['contenttitle']) ? $value['contentsubtitle'] : $value['contenttitle']);
						$_headline= '<strong>'.$this->wordwrapStr(strip_tags($_title)).'</strong>';
						$_content= '<span class="grey">'.$this->wordwrapStr(strip_tags($value['content'])).'</span>';
						break;
				}

				// check hidden content
				$_hidden= ($value['hidden'] == 1) ? ' <small style="color:green;">'.$this->lang['text_hidden'].'</small>' : '';

				// check publication date
				$now = adodb_getdate();
				$notpublished = ($now['0'] < $value['starttime']) ? '<small style="color:green;">'.$this->lang['content_not_published'].'</small>' : '';
				$timeout = ($now['0'] > $value['endtime']) ? '<small style="color:green;">'.$this->lang['content_timeout'].'</small>' : '';

				if ( empty($notpublished)  && empty($timeout) ) {
					$publishedout =$this->lang['content_published'];
				} else {
					$publishedout = empty($notpublished) ? $timeout : $notpublished;
				}

				// prepare for output
				$content .= '
					<li id="item_'.$value['id'].'" class="item'.$this->checkContentType($value['contenttype']).'">
						'.$this->makeCNImageLink(CN_SKINIMAGE.'tool_editcontent.gif', $this->lang['button_edit'],CN_BASEDIR.'/index.php','content',$value['pid'],'','_self','action=edit&cid='.$value['id']).'
						<a href="#" title="'.$this->lang['button_copy'].'" onmouseover="window.status=\'contentnow\';return true;" onclick="this.blur();showContentItem(\''.$this->makeCNurl('./library/function.copyitem.php','content','','cid='.$value['id']).'\',\'copyitem\');"><img src="'.CN_SKINIMAGE.'tool_copy.gif" title="'.$this->lang['button_copy'].'" alt="'.$this->lang['button_copy'].'" border="0" /></a>
						<a href="#" title="'.$this->lang['button_delete'].'" onmouseover="window.status=\'contentnow\';return true;" onclick="this.blur();if ('.$this->confirmMsg().') showContentItem(\''.$this->makeCNurl('./library/function.showitems.php','content','','action=delete&cid='.$value['id']).'\',\'cn_content\');"><img src="'.CN_SKINIMAGE.'tool_delete.gif" title="'.$this->lang['button_delete'].'" alt="'.$this->lang['button_delete'].'" border="0" /></a>
						<small>CID '.$value['id'].' | '.$this->makeDate($value['starttime']).' | '.$publishedout.$_hidden.'</small>
						<p style="margin:5px"></p>
						'.$_headline.'
						<p style="margin:5px"></p>
						'.$_content.'
					</li>';
			}
		}
		return $content;

		case 'list':
		if (empty ($this->contentArray)) {
			// no items found
			$content= '<li class="item">'.$this->lang['content_noitems'].'</li>';
		} else {
			$content= '';

			// start loop
			foreach ($this->contentArray as $value) {

				// prepare output
				$title = '&nbsp;<span class="grey">'.$this->wordwrapStr($this->encodeStr($this->getPageTitle($value['pid'])),20).'</span>';
				$siteLink= $this->makeCNImageLink(CN_SKINIMAGE.'tool_template.gif', $this->lang['button_gopage'].' PID: '.$value['pid'],CN_BASEDIR.'/index.php','content', $value['pid'], '');

				switch ($value['contenttype']) {

					case "3" :
						// generate preview text for modul
						$_previewtext= explode('|*|', $value['content']);
						// array pos 1 -> modul name
						$_headline= $siteLink.'&nbsp;'.$this->lang['text_modul_short'].$title.'&nbsp;<strong>'.$this->wordwrapStr($_previewtext[1],30).'</strong>&nbsp;'.$this->wordwrapStr($this->encodeStr($value['contenttitle']),40);
						break;

					case "2" :
						// generate preview php script
						$_headline= $siteLink.'&nbsp;'.$this->lang['text_contenturl_short'].$title.'&nbsp;<strong>'.$this->encodeStr($this->wordwrapStr($value['contenttitle'],30)).'</strong>&nbsp;'.$this->wordwrapStr($this->lang['content_url'].' '.$value['contenturl'],40);
						break;

					case "1" :
						// generate preview text for teaser content
						$_headline= $siteLink.'&nbsp;'.$this->lang['text_teasercontent_short'].$title.'&nbsp;<strong>'.$this->encodeStr($this->wordwrapStr($value['contenttitle'],30)).'</strong>&nbsp;'.$this->wordwrapStr(strip_tags($value['content']),40);
						break;

					default :
						// generate preview text for text element
						$_headline= $siteLink.'&nbsp;'.$this->lang['text_text_short'].$title.'&nbsp;<strong>'.$this->encodeStr($this->wordwrapStr($value['contenttitle'],30)).'</strong>&nbsp;'.$this->wordwrapStr(strip_tags($value['content']),40);
						break;
				}

				// check hidden content
				$_hidden= ($value['hidden'] == 1) ? $this->lang['text_hidden'] : '';

				// check publication date
				$now = adodb_getdate();
				$notpublished = ($now['0'] < $value['starttime']) ? $this->lang['content_not_published'] : '';
				$timeout = ($now['0'] > $value['endtime']) ? $this->lang['content_timeout'] : '';

				if ( empty($notpublished)  && empty($timeout) ) {
					$publishedout = '<small>'.$this->lang['content_published'].'</small>';
				} else {
					$publishedout = empty($notpublished) ? $timeout : $notpublished;
					$_hidden = '';
				}

				// prepare for output
				$content .= '
					<li id="item_'.$value['id'].'" class="item_list'.$this->checkContentType($value['contenttype']).'">
						'.$this->makeCNImageLink(CN_SKINIMAGE.'tool_editcontent.gif', $this->lang['button_edit'].' CID: '.$value['id'],CN_BASEDIR.'/index.php','content',$value['pid'],'','_self','action=edit&cid='.$value['id']).'
						'.$_headline.' | <small style="color:green;">'.$publishedout.' '.$_hidden.'</small>
					</li>';
			}
		}
		return $content;
		}
	}

	/**
	 * function getContentEditForm()
	 * @descr	Show content edit formular
	 * @param	sid: sort id, number in array = sort in mysql
	 * @return	string
	 * @switch	default: normal text elements | 3: modul element | 2: dynamic php file
	 */

	function getContentEditForm() {

		switch ($this->contentArray[0]['contenttype']) {

			case "3" :
				// parse modul content
				$content= '
					<input type="hidden" name="content[id]" value="'.$this->contentArray[0]['id'].'" />
					<input type="hidden" name="content[tstamp]" value="'.$this->getActualTimeStamp().'" />
					<input type="hidden" name="content[sort]" value="'.$this->contentArray[0]['sort'].'" />
					<input type="hidden" name="contentLanguageSuffix" id="contentLanguageSuffix" value="'.$this->contentLanguageSuffix.'" />
					<li class="item">
						<div class="row_border">
							<div class="label_left">'.$this->lang['content_title'].'</div>
							<input type="text" id="contenttitle" name="content[contenttitle]" value="'.$this->encodeStr($this->contentArray[0]['contenttitle']).'" class="width_400" />
						</div>
				<p style="margin:5px"></p>
						<div class="row_border">
							<div class="label_left">'.$this->lang['content_subtitle'].'</div>
							<input type="text" name="content[contentsubtitle]" value="'.$this->encodeStr($this->contentArray[0]['contentsubtitle']).'" class="width_400" />
							</div>
				<p style="margin:5px"></p>
						<div class="row_border">
							<div class="label_left">'.$this->lang['content_contentsyskey'].'</div>
							<div class="label_left_200">
								<input type="text" name="content[contentsyskey]" id="content_contentsyskey" value="'.$this->encodeStr($this->contentArray[0]['contentsyskey']).'" class="width_120" />'.$this->makeInputClear('content_contentsyskey').'
							</div>
							<div class="label_left">'.$this->lang['content_hidden'].' '.$this->contentCheckBox('content[hidden]', $this->contentArray[0]['hidden']).'</div>
							<div class="label_left_200">'.$this->lang['content_contenttype'].' '.$this->contenttypeDropDown($this->contentArray[0]['contenttype']).'</div>
						</div>
				<p style="margin:5px"></p>
							<div class="row_border">
									<div class="label_left">'.$this->lang['content_date'].'</div>
									<div class="label_left_200">
										<input type="text" id="content_starttime" name="content[starttime]" value="'.$this->makeDate($this->contentArray[0]['starttime']).'" class="width_120" disabled="true" />'.$this->makeCalendarInput('content_starttime').'
									</div>
									<div class="label_left">'.$this->lang['content_enddate'].'</div>
									<div class="label_left_200">
										<input type="text" id="content_endtime" name="content[endtime]" value="'.$this->makeDate($this->contentArray[0]['endtime']).'" class="width_120" disabled="true" />'.$this->makeCalendarInput('content_endtime').$this->makeInputClear('content_endtime',CN_TIMETOLIVE).'
									</div>
							</div>
				<p style="margin:15px"></p>
					<div class="row_noborder"><strong>'.$this->lang['modul_configuration'].'</strong></div>
						'.$this->getSelectedModulParam($this->contentArray[0]['content']).'
					</li>
					<li class="item_footer">
							'.$this->makeCNAjaxLink($this->lang['button_save'],'./library/function.savemodul.php','formeditcontentitem').'
							'.$this->makeCNAjaxLink($this->lang['button_save_preview'],'./library/function.savemodul.php','formeditcontentitem','../index.php?inline='.$this->configArray[0]['inlineedit'].'&pageid='.$this->pageid.'&clang='.$this->contentLanguage).'
							'.$this->makeCNAjaxLink($this->lang['button_save_close'],'./library/function.savemodul.php','formeditcontentitem',$this->makePOSTLink(),'self').'
							<input type="button" title="'.$this->lang['button_cancel_close'].'" value="'.$this->lang['button_cancel_close'].'" onclick="this.blur();showContentItem(\''.$this->makeCNurl('./library/function.showitems.php','content').'\',\'cn_content\');" class="submit_120" />
					</li>';
				break;

			case "2" :
				// dynamic php script
				$content= '
						<input type="hidden" name="content[id]" value="'.$this->contentArray[0]['id'].'" />
						<input type="hidden" name="content[tstamp]" value="'.$this->getActualTimeStamp().'" />
						<input type="hidden" name="content[sort]" value="'.$this->contentArray[0]['sort'].'" />
						<input type="hidden" name="contentLanguageSuffix" id="contentLanguageSuffix" value="'.$this->contentLanguageSuffix.'" />
						<li class="item" style="border-top: 1px solid #CCC;">
							<div class="row_border">
								<div class="label_left">'.$this->lang['content_title'].'</div>
								<input type="text" id="contenttitle" name="content[contenttitle]" value="'.$this->encodeStr($this->contentArray[0]['contenttitle']).'" class="width_400" />
							</div>
						<p style="margin:5px"></p>
							<div class="row_border">
								<div class="label_left">'.$this->lang['content_subtitle'].'</div>
								<input type="text" name="content[contentsubtitle]" value="'.$this->encodeStr($this->contentArray[0]['contentsubtitle']).'" class="width_400" />
							</div>
						<p style="margin:5px"></p>
							<div class="row_border">
								<div class="label_left">'.$this->lang['content_contentsyskey'].'</div>
								<div class="label_left_200">
									<input type="text" name="content[contentsyskey]" id="content_contentsyskey" value="'.$this->contentArray[0]['contentsyskey'].'" class="width_120" />'.$this->makeInputClear('content_contentsyskey').'
								</div>
								<div class="label_left">'.$this->lang['content_hidden'].' '.$this->contentCheckBox('content[hidden]', $this->contentArray[0]['hidden']).'</div>
								<div class="label_left_200">'.$this->lang['content_contenttype'].' '.$this->contenttypeDropDown($this->contentArray[0]['contenttype']).'</div>
							</div>
						<p style="margin:5px"></p>
							<div class="row_border">
									<div class="label_left">'.$this->lang['content_date'].'</div>
									<div class="label_left_200">
										<input type="text" id="content_starttime" name="content[starttime]" value="'.$this->makeDate($this->contentArray[0]['starttime']).'" class="width_120" disabled="true" />'.$this->makeCalendarInput('content_starttime').'
									</div>
									<div class="label_left">'.$this->lang['content_enddate'].'</div>
									<div class="label_left_200">
										<input type="text" id="content_endtime" name="content[endtime]" value="'.$this->makeDate($this->contentArray[0]['endtime']).'" class="width_120" disabled="true" />'.$this->makeCalendarInput('content_endtime').$this->makeInputClear('content_endtime',CN_TIMETOLIVE).'
									</div>
							</div>
						<p style="margin:5px"></p>
							<div class="row_border">
								<div class="label_left">'.$this->lang['content_url'].' '.$this->makeUploadPopUp(CN_UPLOAD_BASEDIR, 'contenturl', 'file','single').'</div>
								<input type="text" id="contenturl" name="content[contenturl]" value="'.$this->encodeStr($this->contentArray[0]['contenturl']).'" class="width_400" />
							</div>
						</li>
						<li class="item_footer">
							'.$this->makeCNAjaxLink($this->lang['button_save'],'./library/function.saveitem.php','formeditcontentitem').'
							'.$this->makeCNAjaxLink($this->lang['button_save_preview'],'./library/function.saveitem.php','formeditcontentitem','../index.php?inline='.$this->configArray[0]['inlineedit'].'&pageid='.$this->pageid.'&clang='.$this->contentLanguage).'
							'.$this->makeCNAjaxLink($this->lang['button_save_close'],'./library/function.saveitem.php','formeditcontentitem',$this->makePOSTLink(),'self').'
							<input type="button" title="'.$this->lang['button_cancel_close'].'" value="'.$this->lang['button_cancel_close'].'" onclick="this.blur();showContentItem(\''.$this->makeCNurl('./library/function.showitems.php','content').'\',\'cn_content\');" class="submit_120" />
							'.$this->makeCNAjaxLink($this->lang['button_newtext'],'./library/function.saveitem.php','formeditcontentitem',$this->makePOSTLink().'&action=new','self').'
						</li>';
				break;

			default :
				// parse text and teaser content
				$content= '
						<input type="hidden" name="content[id]" value="'.$this->contentArray[0]['id'].'" />
						<input type="hidden" name="content[tstamp]" value="'.$this->getActualTimeStamp().'" />
						<input type="hidden" name="content[sort]" value="'.$this->contentArray[0]['sort'].'" />
						<input type="hidden" name="contentLanguageSuffix" id="contentLanguageSuffix" value="'.$this->contentLanguageSuffix.'" />
						<li class="item" style="border-top: 1px solid #CCC;">
							<div class="row_border">
								<div class="label_left">'.$this->lang['content_title'].'</div>
								<input type="text" id="contenttitle" name="content[contenttitle]" value="'.$this->encodeStr($this->contentArray[0]['contenttitle']).'" class="width_400" />
							</div>
						<p style="margin:5px"></p>
							<div class="row_border">
								<div class="label_left">'.$this->lang['content_subtitle'].'</div>
								<input type="text" name="content[contentsubtitle]" value="'.$this->encodeStr($this->contentArray[0]['contentsubtitle']).'" class="width_400" />
							</div>
						<p style="margin:5px"></p>
							<div class="row_border">
								<div class="label_left">'.$this->lang['content_contentsyskey'].'</div>
								<div class="label_left_200">
									<input type="text" name="content[contentsyskey]" id="content_contentsyskey" value="'.$this->encodeStr($this->contentArray[0]['contentsyskey']).'" class="width_120" />'.$this->makeInputClear('content_contentsyskey').'
								</div>
								<div class="label_left">'.$this->lang['content_hidden'].' '.$this->contentCheckBox('content[hidden]', $this->contentArray[0]['hidden']).'</div>
								<div class="label_left_200">'.$this->lang['content_contenttype'].' '.$this->contenttypeDropDown($this->contentArray[0]['contenttype']).'</div>
							</div>
						<p style="margin:5px"></p>
							<div class="row_border">
									<div class="label_left">'.$this->lang['content_date'].'</div>
									<div class="label_left_200">
										<input type="text" id="content_starttime" name="content[starttime]" value="'.$this->makeDate($this->contentArray[0]['starttime']).'" class="width_120" disabled="true" />'.$this->makeCalendarInput('content_starttime').'
									</div>
									<div class="label_left">'.$this->lang['content_enddate'].'</div>
									<div class="label_left_200">
										<input type="text" id="content_endtime" name="content[endtime]" value="'.$this->makeDate($this->contentArray[0]['endtime']).'" class="width_120" disabled="true" />'.$this->makeCalendarInput('content_endtime').$this->makeInputClear('content_endtime',CN_TIMETOLIVE).'
									</div>
							</div>
							<div class="row_noborder">'.$this->getRichTextEdit('content').'
								<textarea id="content" name="content[content]" style="width:99%;">'.$this->contentArray[0]['content'].'</textarea>
							</div>
						</li>
						<li class="item_footer">
							'.$this->makeCNAjaxLink($this->lang['button_save'],'./library/function.saveitem.php','formeditcontentitem').'
							'.$this->makeCNAjaxLink($this->lang['button_save_preview'],'./library/function.saveitem.php','formeditcontentitem','../index.php?inline='.$this->configArray[0]['inlineedit'].'&pageid='.$this->pageid.'&clang='.$this->contentLanguage).'
							'.$this->makeCNAjaxLink($this->lang['button_save_close'],'./library/function.saveitem.php','formeditcontentitem',$this->makePOSTLink(),'self').'
							<input type="button" title="'.$this->lang['button_cancel_close'].'" value="'.$this->lang['button_cancel_close'].'" onclick="this.blur();showContentItem(\''.$this->makeCNurl('./library/function.showitems.php','content').'\',\'cn_content\');" class="submit_120" />
							'.$this->makeCNAjaxLink($this->lang['button_newtext'],'./library/function.saveitem.php','formeditcontentitem',$this->makePOSTLink().'&action=new','self').'
						</li>';
				break;
		}
		return $content;
	}

	/**
	 * function getContentListFooter()
	 * @descr	Show content footer (new element, new modul, sort)
	 * @param	-
	 * @return	string
	 * @used 	function showContent
	 */

	function getContentListFooter() {

		// '.$this->makeCNAjaxImageLink(CN_SKINIMAGE.'tool_insert.gif','./library/function.copyitempaste.php?pid='.$this->pageid,'formeditcontentitem',$this->makeCNurl(CN_BASEDIR.'/index.php','content'),'true','copyitem','',$this->lang['button_moveitem']).'
		$copyItem= (empty ($_SESSION['singleContentArray'])) ? '<div id="copyitem">&nbsp;</div>' : '
							<div id="copyitem">
								<a href="#" title="'.$this->lang['button_moveitem'].'" onmouseover="window.status=\'contentnow\';return true;" onclick="this.blur();showContentItem(\''.$this->makeCNurl('./library/function.showitems.php','content','','action=pasteitem').'\',\'cn_content\');"><img src="'.CN_SKINIMAGE.'tool_insert.gif" title="'.$this->lang['button_moveitem'].'" alt="'.$this->lang['button_moveitem'].'" border="0" /></a>
								&nbsp;
								<a href="#" title="'.$this->lang['button_deleteitem'].'" onmouseover="window.status=\'contentnow\';return true;" onclick="this.blur();showContentItem(\''.$this->makeCNurl('./library/function.copyitemclear.php','content','','').'\',\'copyitem\');"><img src="'.CN_SKINIMAGE.'tool_delinsert.gif" title="'.$this->lang['button_deleteitem'].'" alt="'.$this->lang['button_deleteitem'].'" border="0" /></a>
							</div>';
		$content= '<input type="hidden" name="sortItemArray" id="sortItemArray" />
							<li class="item_footer">
								<div class="row_left">
									<input type="button" title="'.$this->lang['button_newtext'].'" value="'.$this->lang['button_newtext'].'" onclick="changeUrl(\''.$this->makeCNurl(CN_BASEDIR.'/index.php','content').'&action=new\');" class="submit_120" />
									<input type="button" title="'.$this->lang['button_newmodul'].'" value="'.$this->lang['button_newmodul'].'" onclick="changeUrl(\''.$this->makeCNurl(CN_BASEDIR.'/index.php','content').'&action=modul\');" class="submit_120" />
								</div>
								'.$copyItem.'
							</li>';
		return $content;
	}

	/**
	 * function getNewContentForm()
	 * @descr	Show content edit formular new element
	 * @param	-
	 * @return	string
	 */

	function getNewContentForm() {
		$content= '
					<li class="item">
						<input type="hidden" name="content[sort]" value="'.$this->getMaxSortVal().'" />
						<input type="hidden" name="content[tstamp]" value="'.$this->getActualTimeStamp().'" />
						<div class="row_border">
							<div class="label_left">'.$this->lang['content_title'].' </div>
							<input type="text" id="contenttitle" name="content[contenttitle]" value="" class="width_400" />
						</div>
				<p style="margin:5px"></p>
						<div class="row_border">
							<div class="label_left">'.$this->lang['content_subtitle'].'</div>
							<input type="text" name="content[contentsubtitle]" value="" class="width_400" />
						</div>
						<div class="row_border">
							<div class="label_left">'.$this->lang['content_syskey'].'</div>
							<div class="label_left_200"><input type="text" name="content[contentsyskey]" value="" class="width_120" /></div>
							<div class="label_left">'.$this->lang['content_hidden'].' '.$this->contentCheckBox('content[hidden]', '0').'</div>
							<div class="label_left_200">'.$this->lang['content_contenttype'].' '.$this->contenttypeDropDown('init', 'false').'</div>
						</div>
				<p style="margin:5px"></p>
						<div class="row_border">
							<div class="label_left">'.$this->lang['content_date'].'</div>
							<div class="label_left_200"><input type="text" id="content_starttime" name="content[starttime]" value="'.$this->makeDate().'" class="width_120" disabled="true" />'.$this->makeCalendarInput('content_starttime').'</div>
							<div class="label_left">'.$this->lang['content_enddate'].'</div>
							<div class="label_left_200"><input type="text" id="content_endtime" name="content[endtime]" value="'.$this->makeDate($this->makeTstamp(CN_TIMETOLIVE)).'" class="width_120" disabled="true" />'.$this->makeCalendarInput('content_endtime').'</div>
						</div>
					</li>
					<li class="item_footer">
						'.$this->makeCNAjaxLink($this->lang['button_save_and_edit'],'./library/function.newitem.php?pid='.$this->pageid,'formeditcontentitem',$this->makePOSTLink(),'callback','','').'
						<input type="button" title="'.$this->lang['button_cancel'].'" value="'.$this->lang['button_cancel'].'" onclick="changeUrl(\''.$this->makePOSTLink().'\');" class="submit_120" />
					</li>';
				$content .= $this->setJavaFocus('contenttitle');
		return $content;
	}

	/**
	 * function getNewModulForm()
	 * @descr	Show content element modul
	 * @param	-
	 * @return	string
	 */

	function getNewModulForm() {

		// get all Moduls
		$this->getAllModuls();
		$cnModul= new cnModul();

		if (empty ($this->allModulsArray)) {
			$content= '
						<li class="item"><strong>'.$this->lang['modul_noitems'].'</strong>
							<p style="margin:5px"></p>
							<input type="button" title="'.$this->lang['button_cancel'].'" value="'.$this->lang['button_cancel'].'" onclick="changeUrl(\''.$this->makePOSTLink().'\');" class="submit_120" />
						</li>';
		} else {
			$content .= '
						<li class="item">
							<input type="hidden" name="content_tstamp" value="'.$this->getActualTimeStamp().'" />
							<input type="hidden" name="content_sort" value="'.$this->getMaxSortVal().'" />
							<input type="hidden" name="content_type" value="3" />
								<div class="row_border">
									<div class="label_left">'.$this->lang['content_title'].' </div>
									<input type="text" id="content_title" name="content_title" value="" class="width_400" />
								</div>
							<p style="margin:5px"></p>
								<div class="row_border">
									<div class="label_left">'.$this->lang['content_subtitle'].'</div>
									<input type="text" name="content_subtitle" value=""class="width_400" />
								</div>
							<p style="margin:5px"></p>
								<div class="row_border">
									<div class="label_left">'.$this->lang['content_syskey'].'</div>
									<div class="label_left_200"><input type="text" name="content_syskey" value=""class="width_120" /></div>
									<div class="label_left">'.$this->lang['content_hidden'].' '.$this->contentCheckBox('hidden', '0').'</div>
									<div class="label_left_200">'.$this->lang['content_contenttype'].' '.$this->contenttypeDropDown('3').'</div>
								</div>
							<p style="margin:5px"></p>
								<div class="row_border">
									<div class="label_left">'.$this->lang['content_date'].'</div>
									<div class="label_left_200"><input type="text" id="content_starttime" name="content_starttime" value="'.$this->makeDate().'" class="width_120" disabled="true" />'.$this->makeCalendarInput('content_starttime').'</div>
									<div class="label_left">'.$this->lang['content_enddate'].'</div>
									<div class="label_left_200"><input type="text" id="content_endtime" name="content_endtime" value="'.$this->makeDate($this->makeTstamp(CN_TIMETOLIVE)).'" class="width_120" disabled="true" />'.$this->makeCalendarInput('content_endtime').'</div>
								</div>
							<p style="margin:5px"></p>
								<div class="row_noborder">
									<div class="label_left">'.$this->lang['content_insertmodul'].'</div>
									'.$cnModul->parseAllModulsSelect($this->allModulsArray).'
								</div>
						</li>
						<li class="item_footer">
							'.$this->makeCNAjaxLink($this->lang['button_save_and_edit'],'./library/function.newmodul.php?pid='.$this->pageid,'formeditcontentitem',$this->makePOSTLink(),'callback','','').'
							<input type="button" title="'.$this->lang['button_cancel'].'" value="'.$this->lang['button_cancel'].'" onclick="changeUrl(\''.$this->makePOSTLink().'\');" class="submit_120" />
						</li>';
			$content .= $this->setJavaFocus('content_title');
		}
		return $content;
	}

	function getAlternativePagename($lang) {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
		$sql= "SELECT pagename_".$lang." FROM ".CN_TBL_SECTIONS." WHERE pageid = ".$this->pageid;
		$res= $cnDatabase->Execute($sql);
		$row= $res->FetchRow();
		return $row['pagename_'.$lang];
	}

	function getNewUser() {
		$content= '
				<form method="post" action="'.$this->makePOSTLink().'" name="useredit" id="useredit">
				<input type="hidden" name="user[mode]" value="content" />
				<input type="hidden" name="user[backendlanguage]" value="'.$this->lang['language_key'].'" />
				<input type="hidden" name="user[contentlanguage]" value="'.$this->contentLanguage.'" />
				<p class="head">'.$this->lang['user_label_user'].'</p>
					<ul>
						<li class="item">
						<div class="row_left_wide"><div class="label_left">'.$this->lang['user_name'].'</div><input type="text" class="pad_3" id="user_user" name="user[user]" value="" /></div>
						<div class="row_left_wide"><div class="label_left">'.$this->lang['user_password'].'</div><input type="password" class="pad_3" name="user[password]" value="" /></div>
						<div class="row_clear"></div>
						</li>
						<li class="item">
						<div class="row_left_wide"><div class="label_left">'.$this->lang['user_realname'].'</div><input type="text" class="pad_3" name="user[name]" value="" /></div>
						<div class="row_left_wide"><div class="label_left">'.$this->lang['user_realemail'].'</div><input type="text" class="pad_3" name="user[email]" value="" /></div>
						<div class="row_clear"></div>
						</li>
						<li class="item_noborder">
						<div class="row_right_clear">
							<input type="hidden" id="savenewuser" name="savenewuser" value="" />
							<input type="button" title="'.$this->lang['button_save'].'" value="'.$this->lang['button_save'].'" onclick="$(\'savenewuser\').value=1;this.form.submit();" class="submit_120" />
							<input type="button" title="'.$this->lang['button_cancel'].'" value="'.$this->lang['button_cancel'].'" onclick="changeUrl(\''.$this->makePOSTLink().'\');" class="submit_120" />
						</div>
						</li>
					<ul>
				</form>';
		$content .= $this->setJavaFocus('user_user');

		return $content;
	}

	function getInfoUser($userid) {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
		$sql= "SELECT * FROM ".CN_TBL_SESSIONS." WHERE id = ".$userid;
		$res= $cnDatabase->Execute($sql);
		while ($row= $res->FetchRow()) {
			$this->userDataArray= $row;
		}
		$contentStart= '
					<form method="post" action="'.$this->makePOSTLink().'" name="useredit" id="useredit">
					<input type="hidden" name="user[userid]" value="'.$userid.'" />
					<p class="head">'.$this->lang['user_label_user'].'</p>
						<ul>';
		if ($this->userDataArray['group'] == 0) {
			$contentList= '<li class="item"><div class="row">Cannot edit admin ...</div></li>';
		} else {
			$contentList= '
						<li class="item">
							<div class="row_left_wide"><div class="label_left">'.$this->lang['user_name'].'</div><input type="text" class="pad_3" id="user_user" name="user[user]" value="'.$this->encodeStr($this->userDataArray['user']).'" /></div>
							<div class="row_left_wide"><div class="label_left">'.$this->lang['user_password'].'</div><input type="text" class="pad_3" name="user[password]" value="'.$this->encodeStr($this->userDataArray['password']).'" disabled="true" /></div>
							<div class="row_clear"></div>
						</li>
						<li class="item">
							<div class="row_left_wide"><div class="label_left">'.$this->lang['user_realname'].'</div><input type="text" class="pad_3" name="user[name]" value="'.$this->encodeStr($this->userDataArray['name']).'" /></div>
							<div class="row_left_wide"><div class="label_left">'.$this->lang['user_realemail'].'</div><input type="text" class="pad_3" name="user[email]" value="'.$this->encodeStr($this->userDataArray['email']).'" /></div>
							<div class="row_clear"></div>
						</li>
						<li class="item_noborder">
							<div class="row_right_clear">
								'.$this->makeCNAjaxLink($this->lang['button_save'],'./library/function.saveuser.php','useredit','','','user_'.$userid).'
								'.$this->makeCNAjaxLink($this->lang['button_save_close'],'./library/function.saveuser.php','useredit',$this->makePOSTLink(),'self').'
								<input type="button" title="'.$this->lang['button_cancel_close'].'" value="'.$this->lang['button_cancel_close'].'" onclick="changeUrl(\''.$this->makePOSTLink().'\');" class="submit_120" />
							</div>
						</li>';
			$contentList .= $this->setJavaFocus('user_user');
		}
		$contentEnd= '</ul></form>';
		unset ($this->userDataArray);
		return $contentStart.$contentList.$contentEnd;
	}

	function getUserList() {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
		$sql= "SELECT * FROM ".CN_TBL_SESSIONS;
		$res= $cnDatabase->Execute($sql);
		while ($row= $res->FetchRow()) {
			$this->userArray[]= $row;
		}
		foreach ($this->userArray as $value) {
			$parsedDate= ($value['timestamp'] == 0) ? '-' : date('Y-m-d H:i:s', $value['timestamp']);
			$groupName= ($value['group'] == 0) ? 'Admin' : 'User';
			$content .= '
						<li class="item">
						<div class="row">
						<div>';
			$content .= ($value['group'] == 0) ? '' : $this->makeCNImageLink(CN_SKINIMAGE.'tool_editfile.gif', $this->lang['user_edit'],$_SERVER['PHP_SELF'],'user',0,0,'_self','userid='.$value['id']);
			$content .= ($value['group'] == 0) ? '' : $this->makeCNImageLink(CN_SKINIMAGE.'tool_delete.gif', $this->lang['user_delete'],$_SERVER['PHP_SELF'],'user',0,0,'_self','deluserid='.$value['id'],'confirm');
			$content .= '<strong id="user_'.$value['id'].'" style="padding-left: 10px;">'.$this->encodeStr($value['user']).'</strong> | '.$this->lang['user_realname'].' <a href="mailto:'.$this->encodeStr($value['email']).'">'.$this->encodeStr($value['name']).'</a> | <small>('.$groupName.' | '.$this->lang['user_lastlogin'].' '.$parsedDate.')</small></div>
						</div>
						</li>';
		}
		unset ($this->userArray);
		return ''.$content.'</li>';
	}

	function getAllModuls() {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
		$sql= "SELECT * FROM ".CN_TBL_MODUL." WHERE deleted=0";
		$res= $cnDatabase->Execute($sql);
		while ($row= $res->FetchRow()) {
			$this->allModulsArray[]= $row;
		}
	}

	function getSingleModul($modulId) {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
		$sql= "SELECT * FROM ".CN_TBL_MODUL." WHERE id = ".$modulId." AND deleted=0";
		$res= $cnDatabase->Execute($sql);
		return $res->FetchRow();
	}

	function getSelectedModulParam($modulContentArray) {
		// get single modul array by id, explode first string |*|
		$getModulID= explode('|*|', $modulContentArray);
		// get modul config to $this->modulArray
		$modulArray = $this->getSingleModul($getModulID[0]);
		// return html elements
		$cnModul= new cnModul();
		return $cnModul->parseSelectedModulParam($modulArray, $modulContentArray,$this->lang);
	}

	function getMaxSortVal() {
		$array= cnEngine :: getMaxSort();
		return $array['maxsort'] + 1;
	}

	function getRootPageID() {
		$array= cnEngine :: getNavigationArray();
		return $array[1]['pageid'];
	}

	function getActualTimeStamp() {
		$now = adodb_getdate();
		return $now['0'];
	}

	function getPageTitle($pid) {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
		$sql= "SELECT pagename FROM ".CN_TBL_SECTIONS." WHERE pageid=".$pid." LIMIT 0, 30";
		$res= $cnDatabase->Execute($sql);
		$row = $res->FetchRow();
		return $row['pagename'];
	}

	function getBackendLanguage() {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
		$sql= "SELECT backendlanguage FROM ".CN_TBL_CONFIG." WHERE frontendlanguage = 'default';";
		$res= $cnDatabase->Execute($sql);
		$row = $res->FetchRow();
		return $row['backendlanguage'];
	}

	function getRichTextEdit($form) {
		$langGet= empty ($this->lang['language_key']) ? $this->getBackendLanguage() : $this->lang['language_key'];
		if (!empty ($form)) {
			return '
				<script language="javascript" type="text/javascript">
				// <![CDATA[
					initRichTextEditor(\''.$form.'\',\''.$langGet.'\',\''.CN_SKINDIR.'\');
				// ]]>
				</script>';
		} else {
			return '';
		}
	}

	function setSaveNewUser() {
		// only user allowed: group = 1
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
		$sql= "INSERT INTO ".CN_TBL_SESSIONS." (`user`, `password`, `name`, `email`, `group`, `mode`, `backendlanguage`, `contentlanguage`) VALUES (
										'".$this->decodeStr($_POST['user']['user'])."',
										'".md5($this->decodeStr($_POST['user']['password']))."',
										'".$this->decodeStr($_POST['user']['name'])."',
										'".$this->decodeStr($_POST['user']['email'])."',
										'1',
										'".$_POST['user']['mode']."',
										'".$_POST['user']['backendlanguage']."',
										'".$_POST['user']['contentlanguage']."'
									 )";
		$cnDatabase->Execute($sql);
	}

	function setDeleteUser($userId) {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
		$sql= "DELETE FROM ".CN_TBL_SESSIONS." WHERE id=".$userId;
		$cnDatabase->Execute($sql);
	}

	function setDeleteItem($deleteId) {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
		$sql= "UPDATE ".CN_TBL_CONTENT.$this->contentLanguageSuffix." SET deleted = '1' WHERE id=".$deleteId;
		$cnDatabase->Execute($sql);
	}

	function setPasteItem() {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
		$sql= "INSERT INTO ".CN_TBL_CONTENT.$this->contentLanguageSuffix." (pid,content,contenturl,contentsyskey,contentsubtitle,starttime,endtime,tstamp,contenttitle,sort,contenttype) VALUES (
											'".$this->pageid."',
											'".$_SESSION['singleContentArray']['content']."',
											'".$_SESSION['singleContentArray']['contenturl']."',
											'".$_SESSION['singleContentArray']['contentsyskey']."',
											'".$_SESSION['singleContentArray']['contentsubtitle']."',
											'".$_SESSION['singleContentArray']['starttime']."',
											'".$_SESSION['singleContentArray']['endtime']."',
											'".$this->getActualTimeStamp()."',
											'".$_SESSION['singleContentArray']['contenttitle']."',
											'".$this->getMaxSortVal()."',
											'".$_SESSION['singleContentArray']['contenttype']."'
											)";

		$cnDatabase->Execute($sql);
	}

	function setSavePage() {

		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
		$sql= 'SELECT * FROM '.CN_TBL_SECTIONS.' WHERE pageid = '.$this->pageid;
		$res= $cnDatabase->Execute($sql);
		// decode $_POST['section'] vars to UTF8
		foreach ($_POST['section'] as $id => $value) {
			$_POST['section'][$id] = $this->decodeStr($value);
		}

		$sql= $cnDatabase->GetUpdateSQL($res, $_POST['section']);
		if (!empty ($sql)) {
			$res= $cnDatabase->Execute($sql);
		}

		// Move node ($contentnow->pageid) and its children to new parent ($_POST['target_section_id'])
		$tree = new tree();
		$tree->MoveAll($this->pageid, $_POST['target_section_id']);
	}

	function setDuplicatePage() {
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
		$sql= 'SELECT * FROM '.CN_TBL_SECTIONS.' WHERE pageid = '.$this->pageid;
		$res= $cnDatabase->Execute($sql);

		// Insert Tree
		$tree= new tree();
		$parentInfo = $tree->GetParentInfo($this->pageid);
		// decode $_POST['section'] vars to UTF8
		foreach ($_POST['section'] as $id => $value) {
			$_POST['section'][$id] = $this->decodeStr($value);
		}
		$tree->Insert($parentInfo['pageid'], '', $_POST['section']);
		$lastMySQLID= $cnDatabase->Insert_ID();

		/*
		$sqlLangconfig= "SELECT frontendlanguage FROM ".CN_TBL_CONFIG." WHERE frontendlanguage = 'default';";
		$resLangconfig= $cnDatabase->Execute($sqlLangconfig);
		$rowLangconfig = $resLangconfig->FetchRow();
		*/
		$explodeLangrow = cnEngine::getContentLanguage();

		foreach ($explodeLangrow as $lang) {
			if ($lang == 'default') {
				$lang = '';
			} else {
				$lang = '_'.$lang;
			}

			$sql= 'SELECT * FROM '.CN_TBL_CONTENT.$lang.' WHERE pid = '.$this->pageid.' AND deleted = 0';
			$res= $cnDatabase->Execute($sql);
			$duplicatedContentArray = '';
			if ($res->RecordCount() > 0) {
				// Get items
				while ($row = $res->FetchRow()) {
					$sqlKey = '';
					$sqlValue = '';
					foreach ($row as $key => $value) {
						if ($key != 'id') {
							$sqlKey .= '`'.$key.'`,';
							// change pid to new site pageid
							if ($key == 'pid') {
								$sqlValue .= '\''.$lastMySQLID.'\',';
							} else {
								$sqlValue .= '\''.$value.'\',';
							}
						}
					}
					$sqlKey = ' ('.substr($sqlKey,0,-1).')';
					$sqlValue = ' VALUES ('.substr($sqlValue,0,-1).')';
					$duplicatedContentArray[] = 'INSERT INTO '.CN_TBL_CONTENT.$lang.$sqlKey.$sqlValue;
				}
				// Insert items
				foreach ($duplicatedContentArray as $sql) {
					$res= $cnDatabase->Execute($sql);
				}
			}
	}
	}

	function setDeletePage() {
		// delete all content elements from page
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
		// get all languages
		$sql= "SELECT frontendlanguage FROM ".CN_TBL_CONFIG.";";
		$res= $cnDatabase->Execute($sql);
		if ($res->RecordCount() > 0) {
			while ($row = $res->FetchRow()) {
				$frontEndLanguages[] = $row['frontendlanguage'];
			}
		}
		foreach ($frontEndLanguages as $langKey) {
			$langKey = ($langKey == 'default') ? '' : '_'.$langKey;
			$sql= "UPDATE ".CN_TBL_CONTENT.$langKey." SET deleted = '1' WHERE pid=".$this->pageid;
			$res= $cnDatabase->Execute($sql);
		}
		// delete page from tree
		$tree= new tree();
		$tree->Delete($this->pageid);
	}

	function setMovePageUp($position) {
		if (!empty ($position)) {
			// Change node position and all its childrens to
			$tree= new tree();
			$tree->ChangePositionAll($this->pageid, $position, 'before');
		}
	}

	function setMovePageDown($position) {
		if (!empty ($position)) {
			// Change node position and all its childrens to
			$tree= new tree();
			$tree->ChangePositionAll($this->pageid, $position, 'after');
		}
	}

	function setSaveNewPage() {
		// add $_POST['section'] vars to query
		foreach ($_POST['section'] as $id => $value) {
			$_POST['section'][$id] = $this->decodeStr($value);
		}
		// Add new node
		$tree= new tree();
		$tree->Insert($_POST['new_target_section_id'], '', $_POST['section']);
	}

	function setDuplicateContentLanguage($lang='') {

		if (!empty($lang)) {

			$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
			$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);

			// duplicate content
			$cn_content= CN_TBL_CONTENT;
			$cn_content_duplicate = $cn_content.'_'.$lang;
			$sql_content[]= "DROP TABLE IF EXISTS `$cn_content_duplicate`;";
			$sql_content[]= "CREATE TABLE IF NOT EXISTS `$cn_content_duplicate` (
							`id` int(11) NOT NULL auto_increment,
							`pid` int(11) NOT NULL default '',
							`sort` int(11) NOT NULL default '',
							`hidden` int(11) NOT NULL default '0',
							`tstamp` int(11) NOT NULL default '0',
							`starttime` int(11) NOT NULL default '0',
							`endtime` int(11) NOT NULL default '0',
							`deleted` int(11) NOT NULL default '0',
							`contenttype` int(11) NOT NULL default '0',
							`contentsyskey` varchar(255) NOT NULL default '',
							`contenttitle` varchar(255) NOT NULL default '',
							`contentsubtitle` varchar(255) NOT NULL default '',
							`contenturl` varchar(255) NOT NULL default '',
							`content` text NOT NULL,
							PRIMARY KEY  (`id`)
							) TYPE=MyISAM;";
			$sql_content[]= "INSERT INTO `$cn_content_duplicate` SELECT * FROM `$cn_content`;";
			foreach ($sql_content as $value) {
				$cnDatabase->Execute($value);
			}

			// new config item for new content language
			$sql_config= 'SELECT * FROM '.CN_TBL_CONFIG.' WHERE frontendlanguage = \'default\';';
			$res_config= $cnDatabase->Execute($sql_config);
			$row_config = $res_config->FetchRow();
			$sqlKey='';
			$sqlValue='';
			foreach ($row_config as $key => $value) {
					if ($key != 'id') {
						$sqlKey .= '`'.$key.'`,';
						// change frontendlanguage to new language
						if ($key == 'frontendlanguage') {
							$sqlValue .= '\''.$lang.'\',';
						} else {
							$sqlValue .= '\''.addslashes($value).'\',';
						}
					}
			}
			$sqlKey = ' ('.substr($sqlKey,0,-1).')';
			$sqlValue = ' VALUES ('.substr($sqlValue,0,-1).')';
			$sql_config = 'INSERT INTO '.CN_TBL_CONFIG.$sqlKey.$sqlValue;
			$res_config= $cnDatabase->Execute($sql_config);

			// duplicate alternative pagename: alter sections table
			$sql[]= "ALTER TABLE ".CN_TBL_SECTIONS." ADD `pagename_".$lang."` varchar(255) NOT NULL default ''";
			$sql_section= "SELECT pagename,pageid FROM ".CN_TBL_SECTIONS." WHERE pageid != 1";
			$res_section= $cnDatabase->Execute($sql_section);
			while ($row_section= $res_section->FetchRow()) {
				$sql[] = "UPDATE ".CN_TBL_SECTIONS." SET pagename_".$lang." = '".$row_section['pagename']."' WHERE pageid=".$row_section['pageid'];
			}
			foreach ($sql as $value) {
				$cnDatabase->Execute($value);
			}

		}

	}

	function setJavaFocus($focus= '') {
		if (!empty ($focus)) {
			return '
			<script type="text/javascript" language="javascript">
			// <![CDATA[ // ]]>
				window.onload = function(){$(\''.$focus.'\').focus();}
			// ]]>
			</script>';
		} else {
			return '';
		}
	}

	function makeUploadPopUp($path= '', $cid= '', $type= '', $single='') {
		$path= empty ($path) ? '?path=/no_path_configured' : '?path='.$path;
		$cid= empty ($cid) ? '' : '&cid='.$cid;
		$type= empty ($type) ? '' : '&type='.$type;
		$single= empty ($single) ? '' : '&single=true';
		return '<a href="#" onmouseover="window.status=\'contentnow\';return true;" onclick="SC_show(\''.$this->lang['label_filemanager'].'\', \'./upload.php'.$path.$cid.$type.$single.'\', 400, 800);this.blur();"><img src="'.CN_SKINIMAGE.'tool_link.gif'.'" border="0" alt=""></a>';
	}

	function makeToggleLink($div,$text='') {
		return '<a href="#" onmouseover="window.status=\'contentnow\';return true;" onclick="Effect.toggle(\''.$div.'\',\'slide\',\''.$div.'_img\',{duration:1}); this.blur(); return false;"><img src="'.CN_SKINIMAGE.'tool_plus.gif'.'" id="'.$div.'_img" border="0" alt="">'.$text.'</a>';
	}

	/**
	 * function makeCNAjaxLink()
	 *
	 * @descr	hmtl ouput link
	 * @param	name, request_url, updated_div, class
	 * @return	string
	 * @java 	function populateContentVars(updateUrl,formId,theUrl,targetSelf)
	 * @example 	$this->makeCNAjaxLink('linkname','function.php','formname','callbackurl.php','self','updateDiv','className');
	 */
	function makeCNAjaxLink($name='', $updateUrl='', $formId='', $theUrl='', $targetSelf='', $updateDiv='', $class='' ) {

		$name= empty ($name) ? 'no_name_defined' : $name;
		$updateDiv= empty ($updateDiv) ? '' : $updateDiv;
		$class= empty ($class) ? ' class="submit_120"' : ' class="'.$class.'"';

		if (empty($updateUrl) || empty ($formId)) {
			return 'Error generating Ajax Link ...';
		} else {
			return '<input type="button" title="'.$name.'" value="'.$name.'" onclick="this.blur();populateContentVars(\''.$updateUrl.'\',\''.$formId.'\',\''.$theUrl.'\',\''.$targetSelf.'\',\''.$updateDiv.'\');"'.$class.' />';
		}
	}

	/**
	 * function makeCNAjaxImageLink()
	 *
	 * @descr	hmtl ouput link
	 * @param	imageurl, request_url, updated_div, class
	 * @return	string
	 * @java 	function populateContentVars(updateUrl,formId,theUrl,targetSelf)
	 * @example 	$this->makeCNAjaxLink('imageurl','function.php','formname','index.php','self','myDiv','className');
	 */

	function makeCNAjaxImageLink($imageurl='', $updateUrl='', $formId='', $theUrl='', $targetSelf='', $updateDiv='', $class='',$title='' ) {

		$title= empty ($title) ? 'contentnow' : $title;
		$updateDiv= empty ($updateDiv) ? '' : $updateDiv;
		$class= empty ($class) ? '' : ' class="'.$class.'"';

		if (empty($updateUrl) || empty ($formId)) {
			return 'Error generating Ajax Link ...'.$updateUrl.$formId;
		} else {
			return '<a href="#" title="'.$title.'" onmouseover="window.status=\'contentnow\';return true;" onclick="this.blur();populateContentVars(\''.$updateUrl.'\',\''.$formId.'\',\''.$theUrl.'\',\''.$targetSelf.'\',\''.$updateDiv.'\');"'.$class.'><img src="'.$imageurl.'" title="'.$title.'" alt="'.$title.'" border="0" /></a>';
		}
	}

	/**
	 * function makeCNAjaxNormalLink() NOT USED
	 *
	 * @descr	hmtl ouput link
	 * @param	imageurl, request_url, updated_div, class
	 * @return	string
	 * @java 	-
	 * @example 	-
	 */

	/*
	function makeCNAjaxNormalLink($name='', $updateUrl='', $updateDiv='', $class='', $successMsg='', $successDiv='' ) {
		$mode= '?mode='.$this->mode;
		$pageid= '&pageid='.$this->pageid;

		$name= empty ($name) ? 'no_name_defined' : $name;
		$updateDiv= empty ($updateDiv) ? '' : $updateDiv;
		$class= empty ($class) ? '' : ' class="'.$class.'"';

		$langGet= empty ($this->lang['language_key']) ? '&lang='.$this->getBackendLanguage() : '&lang='.$this->lang['language_key'];
		$cLangGet= empty ($this->contentLanguage) ? '' : '&clang='.$this->contentLanguage;

		if (empty($updateUrl) ) {
			return 'Error generating Ajax Link ...'.$updateUrl;
		} else {
			$updateUrl = $updateUrl.$mode.$pageid.$langGet.$cLangGet;
			return '<a href="#" title="'.$name.'" onmouseover="window.status=\'contentnow\';return true;" onclick="this.blur();showContentVars(\''.$updateUrl.'\',\''.$updateDiv.'\');"'.$class.'>'.$name.'</a>';
		}
	}
*/
	/**
	 * function makeCNLink()
	 *
	 * @descr	hmtl ouput link
	 * @param	name url mode pageid lang class target addUrlParam
	 * @return	string
	 * @example 	$this->makeCNLink('linkname',$_SERVER['PHP_SELF'],'mode','pageid','class_button','target','addParam');
	 */
	function makeCNLink($name= '', $url= '', $mode= '', $pageid= '', $class= '', $target= '', $addUrlParam= '') {
		$name= empty ($name) ? 'no_name_defined' : $name;
		$url= empty ($url) ? '#' : $url;
		$mode= empty ($mode) ? '?mode='.$this->mode : '?mode='.$mode;
		$pageid= empty ($pageid) ? '&pageid='.$this->pageid : '&pageid='.$pageid;
		$class= empty ($class) ? '' : ' class="'.$class.'"';
		$target= empty ($target) ? '_self' : $target;
		$addUrlParam= empty ($addUrlParam) ? '' : '&'.$addUrlParam;
		$langGet= empty ($this->lang['language_key']) ? '&lang='.$this->getBackendLanguage() : '&lang='.$this->lang['language_key'];
		$cLangGet= empty ($this->contentLanguage) ? '' : '&clang='.$this->contentLanguage;
		return '<a href="'.$url.$mode.$pageid.$langGet.$addUrlParam.$cLangGet.'" onmouseover="window.status=\'contentnow\';return true;" onclick="this.blur();" title="'.$name.'"'.$class.' target="'.$target.'">'.$name.'</a>';
	}

	function makeCNImageLink($imageurl='', $name= '', $url= '', $mode= '', $pageid= '', $class= '', $target= '', $addUrlParam= '', $addConfirm='') {
		$name= empty ($name) ? 'no_name_defined' : $name;
		$url= empty ($url) ? '#' : $url;
		$mode= empty ($mode) ? '?mode='.$this->mode : '?mode='.$mode;
		$pageid= empty ($pageid) ? '&pageid='.$this->pageid : '&pageid='.$pageid;
		$class= empty ($class) ? '' : ' class="'.$class.'"';
		$target= empty ($target) ? '_self' : $target;
		$addUrlParam= empty ($addUrlParam) ? '' : '&'.$addUrlParam;
		$langGet= empty ($this->lang['language_key']) ? '&lang='.$this->getBackendLanguage() : '&lang='.$this->lang['language_key'];
		$cLangGet= empty ($this->contentLanguage) ? '' : '&clang='.$this->contentLanguage;
		$addConfirm= empty ($addConfirm) ? '' : 'return '.$this->confirmMsg().';';
		return '<a href="'.$url.$mode.$pageid.$langGet.$addUrlParam.$cLangGet.'" onmouseover="window.status=\'contentnow\';return true;" onclick="this.blur();'.$addConfirm.'" title="'.$name.'"'.$class.' target="'.$target.'"><img src="'.$imageurl.'" alt="'.$name.'" title="'.$name.'" border="0"></a>';
	}

	function makeCNurl($url= '', $mode= '', $pageid= '',$addUrlParam= '') {
		$url= empty ($url) ? '' : $url;
		$mode= empty ($mode) ? '?mode='.$this->mode : '?mode='.$mode;
		$pageid= empty ($pageid) ? '&pageid='.$this->pageid : '&pageid='.$pageid;
		$addUrlParam= empty ($addUrlParam) ? '' : '&'.$addUrlParam;
		$langGet= empty ($this->lang['language_key']) ? '&lang='.$this->getBackendLanguage() : '&lang='.$this->lang['language_key'];
		$cLangGet= empty ($this->contentLanguage) ? '' : '&clang='.$this->contentLanguage;
		return $url.$mode.$pageid.$langGet.$addUrlParam.$cLangGet;
	}

	function makeCNlanguageUrl($url= '',$addUrlParam= '') {
		$mode='?mode='.CN_MODE;
		$pageid= '&pageid='.$this->pageid;

		$url= empty ($url) ? '#' : $url;
		$addUrlParam= empty ($addUrlParam) ? '' : '&'.$addUrlParam;
		$langGet= empty ($this->lang['language_key']) ? '&lang='.$this->getBackendLanguage() : '&lang='.$this->lang['language_key'];
		return $url.$mode.$pageid.$langGet.$addUrlParam;
	}

	function makePOSTLink($mode= '',$overrideLanguage='') {
		$mode= empty ($mode) ? '?mode='.$this->mode : '?mode='.$mode;
		$pageid= empty ($this->pageid) ? '&pageid='.$this->getRootPageID() : '&pageid='.$this->pageid;
		$langGet= empty ($this->lang['language_key']) ? '&lang='.$this->getBackendLanguage() : '&lang='.$this->lang['language_key'];
		// override backend language
		$langGet= (!empty($overrideLanguage)) ? '' : $langGet;
		$cLangGet= empty ($_GET['clang']) ? '' : '&clang='.$_GET['clang'];
		// make ajax ready
		$url = (substr($_SERVER['PHP_SELF'],-9,-4) == 'index') ? $_SERVER['PHP_SELF'] : CN_BASEDIR.'/index.php';
		return $url.$mode.$pageid.$langGet.$cLangGet;
	}

	function makeTstamp($string) {
		// make tstamp
		list($date,$clock) = explode(' ',$string);
		list($mday,$mon,$year) = explode('.',$date);
		list($hours,$minutes) = explode(':',$clock);
		return adodb_mktime($hours,$minutes,0,$mon,$mday,$year);
	}

	function makeDate($dateStr = '') {
		// make readable date
		$now = empty($dateStr) ? adodb_getdate() : adodb_getdate($dateStr);
		return sprintf('%02d',$now['mday']).'.'.sprintf('%02d',$now['mon']).'.'.$now['year'].' '.sprintf('%02d',$now['hours']).':'.sprintf('%02d',$now['minutes']);
	}

	function makeInputClear($identifier='',$value='') {
		if (!empty($identifier)) {
			return '&nbsp;<a href="#" onClick="this.blur();$(\''.$identifier.'\').value=\''.$value.'\';"><img src="'.CN_SKINIMAGE.'tool_minus.gif'.'" border="0" title="'.$this->lang['content_clear'].'" alt="'.$this->lang['content_clear'].'" /></a>';
		} else {
			return '';
		}
	}

	function makeCalendarInput($identifier='') {
		if (!empty($identifier)) {
			return ' <img src="'.CN_SKINIMAGE.'tool_calendar.gif" id="trigger_calendar" style="cursor:pointer;" alt="'.$this->lang['content_calendar'].'" title="'.$this->lang['content_calendar'].'" />
					<script type="text/javascript" language="javascript">
						// <![CDATA[
							Calendar.setup({inputField:"'.$identifier.'",button:"trigger_calendar"});
						// ]]>
					</script>';
		} else {
			return '';
		}
	}

	function makeAccesKeys() {
		$content= '
		<button accesskey="1" onclick="location.href=\''.$this->makePOSTLink('content').'\';">SiteContent</button>
		<button accesskey="2" onclick="location.href=\''.$this->makePOSTLink('meta').'\';">SiteMeta</button>
		<button accesskey="3" onclick="location.href=\''.$this->makePOSTLink('user').'\';">User</button>
		<button accesskey="4" onclick="location.href=\''.$this->makePOSTLink('config').'\';">Siteinfo</button>
		<button accesskey="5" onclick="location.href=\''.$this->makePOSTLink('modul').'\';">Module</button>
		<button accesskey="l" onclick="location.href=\'logout.php\';">LogOut</button>';
		return $content;
	}

	function contenttypeDropDown($input, $inputchange= '') {
		$onchange= ($inputchange == '') ? ' onchange="this.blur();populateContentVars(\'./library/function.saveitem.php\',\'formeditcontentitem\')"' : '';
			switch ($input) {
				case 'init':
					$out= '<select name="content[contenttype]" class="width_120"'.$onchange.'>
							<option value="0" selected>'.$this->lang['select_contenttype_content'].'
							<option value="1">'.$this->lang['select_contenttype_teaser'].'
							<option value="2">'.$this->lang['select_contenttype_dynamic'].'
							</select>';
				break;
				case '0'  :
					$out= '<select name="content[contenttype]" class="width_120"'.$onchange.'>
							<option value="0" selected>'.$this->lang['select_contenttype_content'].'
							<option value="1">'.$this->lang['select_contenttype_teaser'].'
							</select>';
				break;
				case '1'  :
					$out= '<select name="content[contenttype]" class="width_120"'.$onchange.'>
							<option value="0" >'.$this->lang['select_contenttype_content'].'
							<option value="1" selected>'.$this->lang['select_contenttype_teaser'].'
							</select>';
				break;
				case '2'  :
					$out= $this->lang['select_contenttype_dynamic'];
				break;
				case '3'  :
					$out= $this->lang['select_contenttype_modul'];
				break;
			}
		return $out;
	}

	function checkContentType($checkCtype) {
		switch ($checkCtype) {
			case '1' :
				return '_teaser';

			case '2' :
				return '_dynamic';

			case '3' :
				return '_modul';

			default :
				return '_text';
		}
	}

	function checkPageType($checkPtype) {
		switch ($checkPtype) {
			case '1' :
				return 'plugin/dtree/img/sys.gif';

			case '2' :
				return 'plugin/dtree/img/shortcut.gif';

			case '3' :
				return 'plugin/dtree/img/shortcut.gif';

			default :
				return '';
		}
	}

	/**
	 * function checkAccess()
	 * @descr	Check from config array if user have access
	 * @param	-
	 * @return	boolean
	 */

	function checkAccess($access) {
		if ($_SESSION["group"] == 0) return true;
		global $CN_GLOBAL;
		if ($CN_GLOBAL['access'][$access]) return true;
		return false;
	}

	function contentCheckBox($name, $input) {
		return ($input == 0) ? '<input type="hidden" name="'.$name.'" value="0"><input name="'.$name.'" type="checkbox" value="1" class="width_20" />' : '<input type="hidden" name="'.$name.'" value="0"><input name="'.$name.'" type="checkbox" value="1" checked="checked" class="width_20" />';
	}

	function pagetypeDropDown($pagetype) {

		switch ($pagetype) {
			case "1" :
				$out= '<select name="section[pagetype]">
										<option value="0">'.$this->lang['select_page'].'
										<option value="1" selected>'.$this->lang['select_folder'].'
										<option value="2">'.$this->lang['select_urlextern'].'
										<option value="3">'.$this->lang['select_shortcut'].'</select>';
				break;

			case "2" :
				$out= '<select name="section[pagetype]">
										<option value="0">'.$this->lang['select_page'].'
										<option value="1">'.$this->lang['select_folder'].'
										<option value="2" selected>'.$this->lang['select_urlextern'].'
										<option value="3">'.$this->lang['select_shortcut'].'</select>';
				break;

			case "3" :
				$out= '<select name="section[pagetype]">
										<option value="0">'.$this->lang['select_page'].'
										<option value="1">'.$this->lang['select_folder'].'
										<option value="2">'.$this->lang['select_urlextern'].'
										<option value="3" selected>'.$this->lang['select_shortcut'].'</select>';
				break;

			default :
				$out= '<select name="section[pagetype]">
										<option value="0" selected>'.$this->lang['select_page'].'
										<option value="1">'.$this->lang['select_folder'].'
										<option value="2">'.$this->lang['select_urlextern'].'
										<option value="3">'.$this->lang['select_shortcut'].'</select>';
				break;
		}
		return $out;
	}

	function backendLanguageDropDown($formName, $selected='') {
		global $CN_GLOBAL;
		$select = '';
		foreach ($CN_GLOBAL['backend_language'] as $id => $value) {
					$_select = ($selected == $id) ? ' selected' : '';
					$select.= '<option value="'.$id.'"'.$_select.'>'.$value;
			}
		// manual creating Ajax Link
		return '<select name="'.$formName.'" id="backendlanguage" style="width:120px;" onchange="populateContentVars(\'./library/function.saveconfig.php\',\'formeditconfig\',\''.$_SERVER['PHP_SELF'].'?mode='.$this->mode.'&pageid='.$this->pageid.'&clang='.$_GET['clang'].'&lang=\'+$(\'backendlanguage\').value,\'self\',\'cn_pagemessage\');">'.$select.'</select>';
	}

	function frontendLanguageDropDown($formName, $selected='') {
		global $CN_GLOBAL;
		$select = '';
		// get all languages
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
		$sql= "SELECT frontendlanguage FROM ".CN_TBL_CONFIG.";";
		$res= $cnDatabase->Execute($sql);
		if ($res->RecordCount() > 0) {
			while ($row = $res->FetchRow()) {
				$frontEndLanguages[] = $row['frontendlanguage'];
			}
		}
		foreach ($CN_GLOBAL['content_language'] as $id => $value) {
				if (!in_array($id,$frontEndLanguages)) {
					$_select = ($selected == $id) ? ' selected' : '';
					$select.= '<option value="'.$id.'"'.$_select.'>'.$value;
				}
			}
		if ($select == '') $select = '<option value="" selected>---';
		return '<select name="'.$formName.'" style="width:120px;">'.$select.'</select>';
	}

	function contentLanguageDropDown($name,$selected='',$onlySelect=FALSE) {
		global $CN_GLOBAL;
		$out = '';
		$select = '';
		$langArray  = cnEngine::getContentLanguage();
		if (count($langArray) > 1) {
			foreach ($langArray as $value) {
				if ($value == 'default') {
					$_select = (empty($selected)) ? ' selected' : '';
					$select.= '<option value=""'.$_select.'>'.$value;
				} else {
					$_select = ($selected == $value) ? ' selected' : '';
					$select.= '<option value="'.$value.'"'.$_select.'>'.$CN_GLOBAL['content_language'][$value];
				}
			}
		$outSelect = '<select name="'.$name.'" style="width:120px;" onchange="document.location=\''.$this->makeCNlanguageUrl($_SERVER['PHP_SELF'], 'clang=').'\'+this.value">'.$select.'</select>';
		$out = '
		<p class="head">'.$this->lang['link_language'].'</p>
		<div style="padding: 5px;">'.$outSelect.'</div>';
		}
		if (!$onlySelect) {
			return $out;
		} else {
			return $outSelect;
		}
	}

	function encodeStr($str) {
		return str_replace('"', '&quot;', stripslashes($str));
	}

	// experimental
	/*
	function convertQuotes($str) {
		//return htmlentities($str);
    	return str_replace('"', '&quot;', $str);
	}
	*/


	function decodeStr($in) {
		return utf8_decode($in);
	}

	/**
	 * function wordwrapStr()
	 * @descr 	-
	 * @param 	$str
	 * @return 	string
	 */

	function wordwrapStr($str='',$count='') {
		// if empty return no entry
		if (empty($str)) return '-';
		// define default max char length
		$count = empty($count) ? 100 : $count;
		// if string char length < max char lenght return org string
		if (strlen($str)<$count) return $str;
		// wrap string
		$str = wordwrap($str,$count,'[_n_]',0);
		$str = explode('[_n_]',$str);
		$str = $str[0];
		// if the first word > max char length return substring
		if (strlen($str)>$count) $str = substr($str,0,$count);
		// return string with suffix
		return $str.' ...';
	}
	
	/**
	 * function wordwrapStr()
	 * @descr 	-
	 * @param 	$str
	 * @return 	string
	 */
	 
	function secureCheckServerVars() {
		if(isset($_POST) && count($_POST)) {
			foreach($_POST as $key => $value) {
				if(!is_array($_POST[$key])) {
					$_POST[$key] = $this->removeUnsecureTags($value);
				}		
			}
		}
		if(isset($_GET) && count($_GET)) {
			foreach($_GET as $key => $value) {
				$_GET[$key] = $this->removeUnsecureTags($value);
			}
		}
	}
	
	function removeUnsecureTags($check) {
		$check = preg_replace('/\{PHP:(.*?)\}/i', '$1', $check);
		$check = preg_replace('/\{PHPVAR:(.*?)\}/si', '$1', $check);
		$check = preg_replace('/\[PHP\](.*?)\[\/PHP\]/si', '$1', $check);
		$check = preg_replace('/\{URL:(.*?)\}/i', '$1', $check);
		$check = str_replace('[PHP]', '[ PHP ]', $check);
		$check = str_replace('[/PHP]', '[ /PHP ]', $check);
		$check = str_replace('{PHP:', '{ PHP :', $check);
		$check = str_replace('{PHPVAR:', '{ PHPVAR :', $check);
		$check = str_replace('{URL:', '{ URL :', $check);
		return $check;
	}
	
	function checkForSecureVar ($check,$needle='') {
		if ($check == $needle) die ('<span style="font:13px sans-serif;">Security alert! You are not allowed to do this! (1)</span>');	
		if ( strpos($check, ".") === false) {
			return str_replace('%', '', $check);
		} else {	
			die ('<span style="font:13px sans-serif;">Security alert! You are not allowed to do this! (2)</span>');	
		}
	}
	

	function confirmMsg($msg='') {
		$msg = empty($msg) ? $this->lang['content_confirmdelete'] : $msg;
		return 'confirm(\''.$msg.'\')';
	}

// end of class
}