<?php
/**
 *
 * ContentNow | Small Content Management System
 *
 * Copyright (C) 2005/2006 Andre Michaelis <kontakt@michaelis-freunde.de>
 *
 * This file may be distributed and/or modified under the terms of the
 * "GNU General Public License" version 2 as published by the Free
 * Software Foundation and appearing in the file LICENSE included in
 * the packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 *
 * The "GNU General Public License" (GPL) is available at
 * http://www.gnu.org/copyleft/gpl.html.
 *
 */

	// define global params
	$CN_GLOBAL = array(
		'content_language' => array (
					'de'=>'deutsch',
					'en'=>'english',
					'nl'=>'dutch',
					'sv'=>'swedish',
					'tr'=>'turkish',
					),
		'backend_language' => array (
					'de'=>'deutsch',
					'en'=>'english',
					'nl'=>'dutch',
					'sv'=>'swedish',
					'tr'=>'turkish',
					),
		'js_source' => array (
					'scriptaculous/prototype.js' => 'scriptaculous/prototype.js',
					'scriptaculous/scriptaculous.js' => 'scriptaculous/scriptaculous.js',
					'dtree/dtree.js' => 'dtree/dtree.js',
					'jscalendar/calendar_stripped.js' => 'jscalendar/calendar_stripped.js',
					'jscalendar/calendar_en.js' => 'jscalendar/calendar_en.js',
					'tiny_mce/tiny_mce.js' => 'tiny_mce/tiny_mce.js',
					'multiple-file-element/multifile.js' => 'compressed.js',
					'contentnow/contentnow.js' => 'compressed.js',
					'tooltip/tooltip.js' => 'compressed.js',
					),
		'access' => array (
					'content' => true,
					'meta' => true,
					'list' => true,
					'user' => false,
					'modul' => false,
					'config' => true,
					'filemanager' => true,
					'preview' => true,
					'config_templateconfiguration' => false,
					'config_localconfiguration' => false,
					'config_metaconfiguration' => true,
					'config_metaconfiguration_copyright' => false,
					'config_metaconfiguration_description' => true,
					'config_metaconfiguration_keywords' => true,
					'config_functions' => false,
					'config_globalconfiguration' => true,
					'config_languages' => false,
					'config_constants' => false,
					'config_infocn' => true,
					)
	);

	define('CN_CONTENT_LANGUAGE',		'');									// define default frontend/content language, leave blank for default
	define('CN_LANGUAGE',				'de');									// define default language used in moduls: 'de', 'en', ...
	define('CN_ADMIN_USER',				'admin');								// define admin
	define('CN_ADMIN_PASS',				'password');							// define admin pass
	define('CN_WEBMASTER_EMAIL',		'webmaster@domain.com'); 				// define webmaster email (default admin)
	define('CN_WEBMASTER_NAME',			'Admin'); 								// define webmaster name (default admin)
	define('CN_TIMEOUT',				4800);									// define timeout session
	define('CN_TIMETOLIVE',				'01.01.2030 12:00');					// define content time to live (day.month.year hour:minute)

	define('CN_ROOTDIR',				dirname($_SERVER['SCRIPT_NAME']));		// define root path
	$root = str_replace(array('/cn','/library','/'),'',CN_ROOTDIR);
	define('CN_ROOT',					(!empty($root)) ? '/'.$root : $root);
	define('CN_BASEDIR',				'/cn');									// define cn basedir:
																				// if you install cn outside the webroot,
																				// define the new path here!
																				// e.g. '/new_folder/cn'
	define('CN_UPLOAD_BASEDIR',			CN_ROOT.'/upload/');					// define upload folder
	define('CN_UPLOAD_C_BASEDIR',		CN_ROOT.'/upload_c/');					// define thumbnail folder
	define('CN_MODUL_BASEDIR',			CN_ROOT.CN_BASEDIR.'/modul/');			// define modul folder

	define('CN_STYLESDIR',				'themes/');								// relative path to root
	define('CN_DEFAULTSTYLE',			'default/');							// define default skin
	define('CN_SKINDIR',				CN_STYLESDIR.CN_DEFAULTSTYLE);
	define('CN_SKINIMAGE',				CN_STYLESDIR.CN_DEFAULTSTYLE.'images/');

	define('CN_TBL_PRFX', 				'cn_');
	define('CN_TBL_CONTENT',			CN_TBL_PRFX.'content');
	define('CN_TBL_SECTIONS',			CN_TBL_PRFX.'sections');
	define('CN_TBL_CONFIG',				CN_TBL_PRFX.'config');
	define('CN_TBL_MODUL',				CN_TBL_PRFX.'modul');
	define('CN_TBL_SESSIONS',			CN_TBL_PRFX.'sessions');

	define('CN_IDROOT',					'1');									// do not change
	define('CN_MODE',					'meta');								// do not change
	define('CN_VERSION',				'1.39');								// do not change

	// init AdoDB
	$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;
	$ADODB_DATE_LOCALE = array('d/m/Y','H:i:s');
	define('ADODB_DB_TYPE',			'mysql');
	define('TABLE_FIELDS_CONTENT', 	'`id`, `pid`, `sort`, `hidden`, `tstamp`, `starttime`, `endtime`, `deleted`, `contenttype`, `contentsyskey`, `contenttitle`, `contentsubtitle`, `contenturl`, `content`');
	define('TABLE_FIELDS_CONFIG', 	'`id`, `startpageid`, `teasercontentpageid`, `sitetitle`, `metainfo`, `metadescription`, `metakeywords`, `globalsyskey`, `globalpageimage`, `pageimagetemplate`, `pagefootertemplate`, `pageheadertemplate`, `mastertemplate`, `navigationl1`, `navigationl2`, `teasercontenttemplate`, `contenttemplate`, `printtemplate`, `specialtemplate`, `inlineedit`, `smartycache`, `backendlanguage`, `frontendlanguage`');
	define('TABLE_FIELDS_SESSION',	'`id`, `sid`, `user`, `password`, `name`, `email`, `group`, `timestamp`, `ip`, `pid`, `mode`, `backendlanguage`, `contentlanguage`');

?>
