<?php

/**
 * Project: ContentNow | Small Content Management System
 * File: function.showlist.php
 * Created: 01.03.2006
 *
 * Copyright (C) 2006 Andre Michaelis <kontakt@michaelis-freunde.de>
 *
 * This file may be distributed and/or modified under the terms of the
 * "GNU General Public License" version 2 as published by the Free
 * Software Foundation and appearing in the file LICENSE included in
 * the packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 *
 * The "GNU General Public License" (GPL) is available at
 * http://www.gnu.org/copyleft/gpl.html.
 * 
 */
 
 	// get required classes
	require_once ('../adodb/adodb.inc.php');
	require_once ('./configure.php');	
	require_once ('./class.core.php');	
	require_once ('./class.engine.php');
	require_once ('./class.session.php');
	
	// check authentication	
	$cnSession = new cnSession();
	$cnSession->checkAuthentication();	
	
	// make objects
	$cnCore = new cnCore();
	$cnEngine = new cnEngine();
	
	// get/set language frontend
	$setCLang = (empty($_GET['clang'])) ? '' : $_GET['clang'];
	$cnCore->setContentLanguage($setCLang);
	$cnEngine->setContentLanguage($setCLang);

	// get/set language backend
	$setLang = (empty($_GET['lang'])) ? $cnCore->getBackendLanguage() : $_GET['lang'];
	$cnCore->setBackendLanguage($setLang,'.');
	
	// get/set pageid
	$pid = (empty($_GET['pageid'])) ? $cnCore->getRootPageID() : $_GET['pageid'];
	$cnCore->setId($pid);
	$cnEngine->setId($pid);

	// get mode
	$mode = (empty($_GET['mode'])) ? CN_MODE : $_GET['mode'];
	$cnCore->setMode($mode);

	// set session authentification
	$cnSession->checkAuthentication();
	$errorSessionMsg = $cnSession->refreshUser($pid,$_SESSION["userid"]);
	
	function searchDropDown($param= '',$cnCore) {
		switch ($param) {
			default :
				$out= '<select name="contentsearchnumber" class="width_120" onchange="showContentList(\''.$cnCore->makeCNurl('./library/function.showlist.php').'\',\'formeditcontentitem\',\'cn_content\');">
						<option value="10" selected>'.$cnCore->lang['content_search10'].'
						<option value="20">'.$cnCore->lang['content_search20'].'
						<option value="30">'.$cnCore->lang['content_search30'].'
						<option value="all">'.$cnCore->lang['content_searchall'].'
						</select>';
			break;
			case "20" :
				$out= '<select name="contentsearchnumber" class="width_120" onchange="showContentList(\''.$cnCore->makeCNurl('./library/function.showlist.php').'\',\'formeditcontentitem\',\'cn_content\');">
						<option value="10">'.$cnCore->lang['content_search10'].'
						<option value="20" selected>'.$cnCore->lang['content_search20'].'
						<option value="30">'.$cnCore->lang['content_search30'].'
						<option value="all">'.$cnCore->lang['content_searchall'].'
						</select>';
			break;
			case "30" :
				$out= '<select name="contentsearchnumber" class="width_120" onchange="showContentList(\''.$cnCore->makeCNurl('./library/function.showlist.php').'\',\'formeditcontentitem\',\'cn_content\');">
						<option value="10">'.$cnCore->lang['content_search10'].'
						<option value="20">'.$cnCore->lang['content_search20'].'
						<option value="30" selected>'.$cnCore->lang['content_search30'].'
						<option value="all">'.$cnCore->lang['content_searchall'].'
						</select>';
			break;
			case "all" :
				$out= '<select name="contentsearchnumber" class="width_120" onchange="showContentList(\''.$cnCore->makeCNurl('./library/function.showlist.php').'\',\'formeditcontentitem\',\'cn_content\');">
						<option value="10">'.$cnCore->lang['content_search10'].'
						<option value="20">'.$cnCore->lang['content_search20'].'
						<option value="30">'.$cnCore->lang['content_search30'].'				
						<option value="all" selected>'.$cnCore->lang['content_searchall'].'
						</select>';
			break;				
		}
		return $out;
	}
	
	$P_contentsearchnumber = $_POST['contentsearchnumber'];
	$P_contentsearch = $_POST['contentsearch'];
	
	$_contentsearchnumber = empty($P_contentsearchnumber) ? 10 : $P_contentsearchnumber;
	$_contentsearchstring = $cnCore->decodeStr($P_contentsearch);
	
	// make query		
	$sqlLimit = ($P_contentsearchnumber == 'all') ? '' : 'LIMIT 0,'.$_contentsearchnumber;
	$sqlSearchQuery = empty($_contentsearchstring) 	? 'ORDER by tstamp DESC '.$sqlLimit 
	: 
	'AND (	content LIKE \'%'.htmlentities($_contentsearchstring).'%\' 
	 OR contenttitle LIKE \'%'.$_contentsearchstring.'%\' 
	 OR contentsubtitle LIKE \'%'.$_contentsearchstring.'%\') 
	 ORDER by tstamp DESC '.$sqlLimit;

	// get content list
	$cnCore->setContentArray($cnEngine->getContentListMode($sqlSearchQuery));

	if (empty($errorSessionMsg)) {
		// ajax output
		echo utf8_encode('
			<form method="post" name="formeditcontentitem" id="formeditcontentitem">
			<input type="hidden" id="previewid" name="previewid" value="'.$cnCore->pageid.'" />	
			<p class="head_right">'.$cnCore->lang['link_contentlist'].'</p>
			<ul>'.$cnCore->getContentList('list').'</ul>
			<ul><li class="item_footer_list">
					<div class="row_right_clear">
							<input type="text" id="contentsearch" name="contentsearch" value="'.$cnCore->encodeStr($P_contentsearch).'" class="enter_600" />'.$cnCore->makeInputClear('contentsearch').'
							<p style="margin:10px;"></p>
							<input type="button" title="'.$cnCore->lang['content_search'].'" value="'.$cnCore->lang['content_search'].'" name="contentsearchsubmit" onclick="this.blur();showContentList(\''.$cnCore->makeCNurl('./library/function.showlist.php').'\',\'formeditcontentitem\',\'cn_content\');" class="submit_120" />
							'.searchDropDown($_contentsearchnumber,$cnCore).'
					</div>
				</li>
			</ul>
			</form>');			
	} else {
		// error output
		echo '<p class="head_right">ERROR</p><ul><li class="item_noborder">'.$errorSessionMsg.'</li></ul>';
	}
?>