<?php

/**
 * Project: ContentNow | Small Content Management System
 * File: function.showmeta.php
 * Created: 01.03.2006
 *
 * Copyright (C) 2006 Andre Michaelis <kontakt@michaelis-freunde.de>
 *
 * This file may be distributed and/or modified under the terms of the
 * "GNU General Public License" version 2 as published by the Free
 * Software Foundation and appearing in the file LICENSE included in
 * the packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 *
 * The "GNU General Public License" (GPL) is available at
 * http://www.gnu.org/copyleft/gpl.html.
 * 
 */
 
 	// get required classes
	require_once ('../adodb/adodb.inc.php');
	require_once ('./configure.php');	
	require_once ('./class.core.php');	
	require_once ('./class.engine.php');
	require_once ('./class.session.php');
	require_once ('./class.tree.php');

	// check authentication	
	$cnSession = new cnSession();
	$cnSession->checkAuthentication();

	// make objects
	$cnCore = new cnCore();
	$cnEngine = new cnEngine();
	
	// get/set language frontend
	$setCLang = (empty($_GET['clang'])) ? '' : $_GET['clang'];
	$cnCore->setContentLanguage($setCLang);
	$cnEngine->setContentLanguage($setCLang);

	// get/set language backend
	$setLang = (empty($_GET['lang'])) ? $cnCore->getBackendLanguage() : $_GET['lang'];
	$cnCore->setBackendLanguage($setLang,'.');
	
	// get/set pageid
	$pid = (empty($_GET['pageid'])) ? $cnCore->getRootPageID() : $_GET['pageid'];
	$cnCore->setId($pid);
	$cnEngine->setId($pid);

	// get mode
	$mode = (empty($_GET['mode'])) ? CN_MODE : $_GET['mode'];
	$cnCore->setMode($mode);

	// set session authentification
	$errorSessionMsg = $cnSession->refreshUser($pid,$_SESSION["userid"]);
	
	$cnCore->setNavigationArray($cnEngine->getNavigationArray());
	$cnCore->setPageInfoArray($cnEngine->getPageInfoArray($_POST['deletepage']));
	$cnCore->setConfigArray($cnEngine->getConfigPage());

	if (empty($errorSessionMsg)) {
		// ajax output
		echo utf8_encode($cnCore->showMeta());			
	} else {
		// error output
		echo '<p class="head_right">ERROR</p><ul><li class="item_noborder">'.$errorSessionMsg.'</li></ul>';
	}

?>