<?php
/**
*
* ContentNow | Small Content Management System
*
* Copyright (C) 2005 Andre Michaelis <kontakt@michaelis-freunde.de>
*
* This file may be distributed and/or modified under the terms of the
* "GNU General Public License" version 2 as published by the Free
* Software Foundation and appearing in the file LICENSE included in
* the packaging of this file.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
* THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
* PURPOSE.
*
* The "GNU General Public License" (GPL) is available at
* http://www.gnu.org/copyleft/gpl.html.
* 
*/
class cn_insert_aliascontent {

	function cn_insert_aliascontent ($smarty) {
		$this->smarty = $smarty;
	}
	
	function cn_init_insert_aliascontent ($obj) {
		$this->obj = $obj;
		$this->paramArray = explode('|*|',$this->obj['content']);
		
		// define basic params
		$this->modulID = $this->paramArray[0];
		$this->modulName = $this->paramArray[1];
		$this->modulUrl = $this->paramArray[2];
		
		// define individual params
		// Label: $this->paramArray[3]
		$this->aliascontent_cid = $this->paramArray[4];
		$this->aliascontent_p_cid = $this->paramArray[5];		
		$this->aliascontent_limit = intval($this->paramArray[6]);
		$this->aliascontent_randomize = $this->paramArray[7];
		$this->aliascontent_template = empty($this->paramArray[8]) ? '../cn/modul/'.$this->modulUrl.'/smarty_template_aliascontent.html' : $this->paramArray[8];
		
	}
	
	function cn_parse_insert_aliascontent() {

		// limit sql query
		if (!empty($this->aliascontent_limit)) $limit = 'LIMIT '.$this->aliascontent_limit;

		// get cid from pid
		if (!empty($this->aliascontent_p_cid) ) {
			
			// split input pid
			$aliascontent_p_cid = explode(',',$this->aliascontent_p_cid);

			// make sql query
			$whereSql = ' WHERE ( ';
			foreach ($aliascontent_p_cid as $value) {
				$whereSql .= ' pid = '.$value.' OR';
			}		
			$whereSql = substr($whereSql,0,-3).' ) ';
			
			$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
			$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
			$sql = "SELECT id FROM ".CN_TBL_CONTENT.$whereSql." ".$limit;
			$res = $cnDatabase->Execute($sql);	
			
			if ($res->RecordCount() > 0) {
				while( $row = $res->FetchRow()) {
					$p_cidArray[] = $row['id'];
				}
			}			
		}
	
		// get cid from input
		if (!empty($this->aliascontent_cid) ) {

			// split input cid
			$cidArray = explode(',',$this->aliascontent_cid);
		}
			
		// merge to one array: cid from pid and cid from input
		$cidArrayMerged = array_merge($cidArray, $p_cidArray);
		
		// get content	
		if (!empty($cidArrayMerged)) {
		
			// make sql query
			$whereSql = ' WHERE ( ';
			foreach ($cidArrayMerged as $value) {
				$whereSql .= ' id = '.$value.' OR';
			}		
			$whereSql = substr($whereSql,0,-3).' ) ';
	
			// get mysql object	
			$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
			$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
			$sql = "SELECT * FROM ".CN_TBL_CONTENT.$whereSql." AND deleted = 0 AND contenttype = 0 ORDER by pid,sort ASC ".$limit;
			$res = $cnDatabase->Execute($sql);
			// check entries
			if ($res->RecordCount() > 0) {
				while( $row = $res->FetchRow()) {
					$this->alias_array[] = $row;
				}
			} 
		
		} else {
			$this->alias_array[0]['content'] = 'Nothing found. Please check CID.';
		}
		 
		// randomize sort order
		if ($this->aliascontent_randomize == 'yes') {
			shuffle($this->alias_array);
		}

		$this->smarty->assign('aliasArray', $this->alias_array);	
		return $this->smarty->display($this->aliascontent_template);
	}
	
}

?>