<?php
/**
 *
 * ContentNow | Small Content Management System
 *
 * Copyright (C) 2005 Andre Michaelis <kontakt@michaelis-freunde.de>
 *
 * This file may be distributed and/or modified under the terms of the
 * "GNU General Public License" version 2 as published by the Free
 * Software Foundation and appearing in the file LICENSE included in
 * the packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 *
 * The "GNU General Public License" (GPL) is available at
 * http://www.gnu.org/copyleft/gpl.html.
 *
 */

class cn_insert_feedback {

	function cn_insert_feedback ($smarty) {
		$this->smarty = $smarty;
	}

	function cn_init_insert_feedback ($obj) {
		$this->obj = $obj;
		$this->paramArray = explode('|*|',$this->obj['content']);

		// define basic params
		$this->modulID = $this->paramArray[0];
		$this->modulName = $this->paramArray[1];
		$this->modulUrl = $this->paramArray[2];

		// define individual params
		$this->feedback_sitename = $this->paramArray[3];
		$this->feedback_siteurl = $this->paramArray[4];
		$this->feedback_siteemail = $this->paramArray[5];
		$this->feedback_error_backbutton = (empty($this->paramArray[6])) ? 'Back' : $this->paramArray[6];
		$this->feedback_sitetext = $this->paramArray[7];
		$this->feedback_error_text = (empty($this->paramArray[8])) ? 'Error' : $this->paramArray[8];
		$this->feedback_thankyou_text = (empty($this->paramArray[9])) ? 'Thank you' : $this->paramArray[9];
		$this->feedback_automatictext = (empty($this->paramArray[10])) ? 'Thank you' : $this->paramArray[10];
		$this->feedback_template = empty($this->paramArray[11]) ? '../cn/modul/'.$this->modulUrl.'/smarty_template_feedback.html' : $this->paramArray[11];
		$this->feedback_template_email = empty($this->paramArray[12]) ? '../cn/modul/'.$this->modulUrl.'/smarty_template_feedback_email.html' : $this->paramArray[12];

	}

	function input_check_mailinj($value) {

	   // mail adress(ess) for reports
	   $report_to = CN_WEBMASTER_EMAIL;

	   // array holding strings to check...
	   $suspicious_str = array
	   (
		   "content-type:",
		   "charset=",
		   "mime-version:",
		   "multipart/mixed",
		   "bcc:"
	   );

	   // remove added slashes from $value...
	   $value = stripslashes($value);

	   foreach($suspicious_str as $suspect) {


		   // checks if $value contains $suspect...
		   if(eregi($suspect, strtolower($value))) {
			   $ip = (empty($_SERVER['REMOTE_ADDR'])) ? 'empty' : $_SERVER['REMOTE_ADDR'];
			   $rf = (empty($_SERVER['HTTP_REFERER'])) ? 'empty' : $_SERVER['HTTP_REFERER'];
			   $ua = (empty($_SERVER['HTTP_USER_AGENT'])) ? 'empty' : $_SERVER['HTTP_USER_AGENT'];
			   $ru = (empty($_SERVER['REQUEST_URI'])) ? 'empty' : $_SERVER['REQUEST_URI'];
			   $rm = (empty($_SERVER['REQUEST_METHOD'])) ? 'empty' : $_SERVER['REQUEST_METHOD'];

			   // if so, file a report...
			   if(isset($report_to) && !empty($report_to)) {
				   @mail (
						 $report_to
					   ,"[ABUSE] mailinjection @ " . $_SERVER['HTTP_HOST'] . " by " . $ip
					   ,"Stopped possible mail-injection @ " . $_SERVER['HTTP_HOST'] . " by " . $ip . " (" . date('d/m/Y H:i:s') . ")\r\n\r\n" .
						 "*** IP/HOST\r\n" . $ip . "\r\n\r\n" .
						 "*** USER AGENT\r\n" . $ua . "\r\n\r\n" .
						 "*** REFERER\r\n" . $rf . "\r\n\r\n" .
						 "*** REQUEST URI\r\n" . $ru . "\r\n\r\n" .
						 "*** REQUEST METHOD\r\n" . $rm . "\r\n\r\n" .
						 "*** SUSPECT\r\n--\r\n" . $value . "\r\n--"
				   );
			   }

			   // ... and kill the script.
			   die (
				   'Script processing cancelled: string (`<em>'.$value.'</em>`) contains text portions that are ' .
				   'potentially harmful to this server. <em>Your input has not been sent!</em> Please use your ' .
				   'browser\'s `back`-button to return to the previous page and try refrasing your input.</p>'
			   );
		   }
	   }
	}

	function cn_parse_insert_feedback() {

		if ($_POST['submit_feedback']) {

			// check security
			foreach ($_POST['feedbackform'] as $value) $this->input_check_mailinj($value);

			$firstname = $_POST['feedbackform']['firstname'];
			$lastname = $_POST['feedbackform']['lastname'];
			$email = $_POST['feedbackform']['email'];
			$phone = $_POST['feedbackform']['phone'];
			$message = $_POST['feedbackform']['message'];

			$this->smarty->assign('Firstname', $firstname);
			$this->smarty->assign('Lastname', $lastname);
			$this->smarty->assign('Email', $email);
			$this->smarty->assign('Phone', $phone);
			$this->smarty->assign('Message', $message);
			$this->smarty->assign('Siteurl', $this->feedback_siteurl);
			$this->smarty->assign('Sitename', $this->feedback_sitename);

			$Content = $this->smarty->fetch($this->feedback_template_email);

			if ($firstname != '' && $lastname != '' && $email != '' ) {

				$success = mail($this->feedback_siteemail, "Feedback ".$this->feedback_sitename, $Content, "From: ".$this->feedback_siteemail."\n");
				if ($success == true) {
					$automatic = mail($email, "Feedback ".$this->feedback_sitename, $this->feedback_automatictext, "From: ".$this->feedback_siteemail."\n");
					$out = nl2br($this->feedback_thankyou_text);
				} else {
					$out = 'Error! Please contact the Webmaster ...';
				}

			} else {
					$out = nl2br($this->feedback_error_text).'<br>
							<a href="javascript:history.go(-1);">'.$this->feedback_error_backbutton.'</a>';
			}

		} else {

		$this->smarty->assign('sendtip_formurl', cnEngine::cnGlobalUrlWrapper());
		$this->smarty->assign('Sitetext', $this->feedback_sitetext);

		$out = $this->smarty->fetch($this->feedback_template);

		}
		return $out;
	}

}

?>