<?php

/**
 *
 * ContentNow | Small Content Management System
 *
 * Copyright (C) 2005 Andre Michaelis <kontakt@michaelis-freunde.de>
 *
 * This file may be distributed and/or modified under the terms of the
 * "GNU General Public License" version 2 as published by the Free
 * Software Foundation and appearing in the file LICENSE included in
 * the packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 *
 * The "GNU General Public License" (GPL) is available at
 * http://www.gnu.org/copyleft/gpl.html.
 * 
 */

// define basic params
$modulName = 'Insert Login form';
$modulUrl = 'insert_login_form';
$modulVersion = '0.2';
$modulAuthor = 'andre@michaelis-freunde.de';
$modulDescription = 'Insert Login Form to contentnow. New databse table needed. You can customize the templates in the modul folder.';

// install array additional database table
$modulConf = array (
	'name' => $modulName,
	'version' => $modulVersion,
	'install_type' => 'db_install',
	'modulInstallMsg' => 'Database needs to be updated. Continue?',
	'table_name' => 'cn_' . $modulUrl,
	'table' => array (

		"DROP TABLE IF EXISTS `cn_$modulUrl`;",

		"CREATE TABLE IF NOT EXISTS `cn_$modulUrl` (
						`id` INT NOT NULL auto_increment,
						`title` varchar(255) NOT NULL default '',
						`login` varchar(255) NOT NULL default '',
						`pass` varchar(255) NOT NULL default '',
						`comments` varchar(255) NOT NULL default '',
						`redirect` varchar(255) NOT NULL default '',
						`securitykey` varchar(255) NOT NULL default '',			
						PRIMARY KEY  (`id`)
						)"
	)
);

// define individual params 
/**
 * array (input name, input type, param, contentParam),	
 * @param	input name:
 * 			input type:	chooseFile : param -> form name/id; contentParam -> (upload dir | upload type: file, dir | add single or multiple values)
 * 						chooseID : 
 * 						db : param -> display fields; contentParam -> edit fields
 * 						input : 
 */

$params = array (
	array (
		'login_form_template_input',
		'chooseFile',
		'login_form_template_input',
		CN_UPLOAD_BASEDIR . '|file|single'
	),
	array (
		'login_form_template_post',
		'chooseFile',
		'login_form_template_post',
		CN_UPLOAD_BASEDIR . '|file|single'
	),
	array (
		'login_form_template_function',
		'functionFile',
		'',
		'./modul/' . $modulUrl . '/save.php|_blank'
	),
	array (
		'login_form_template_db',
		'db',
		'title|comments',
		'title|login|pass|comments|redirect|securitykey'
	),
	
);
?>