<?php
/**
 *
 * ContentNow | Small Content Management System
 *
 * Copyright (C) 2005 Andre Michaelis <kontakt@michaelis-freunde.de>
 *
 * This file may be distributed and/or modified under the terms of the
 * "GNU General Public License" version 2 as published by the Free
 * Software Foundation and appearing in the file LICENSE included in
 * the packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 *
 * The "GNU General Public License" (GPL) is available at
 * http://www.gnu.org/copyleft/gpl.html.
 * 
 */

class cn_insert_mini_forum {

	function cn_insert_mini_forum ($smarty) {
		$this->smarty = $smarty;
	}
	
	function cn_init_insert_mini_forum ($obj) {
	
		$this->obj = $obj;
		$this->paramArray = explode('|*|',$this->obj['content']);
		
		// define basic params
		$this->modulID = $this->paramArray[0];
		$this->modulName = $this->paramArray[1];
		$this->modulUrl = $this->paramArray[2];
		
		// define individual params
		$this->forum_template_list = empty($this->paramArray[3]) ? '../cn/modul/'.$this->modulUrl.'/smarty_template_forum_list.html' : $this->paramArray[3];
		$this->forum_template_detail = empty($this->paramArray[4]) ? '../cn/modul/'.$this->modulUrl.'/smarty_template_forum_detail.html' : $this->paramArray[4];
		$this->forum_template_post = empty($this->paramArray[5]) ? '../cn/modul/'.$this->modulUrl.'/smarty_template_forum_post.html' : $this->paramArray[5];
		$this->forum_template_reply = empty($this->paramArray[6]) ? '../cn/modul/'.$this->modulUrl.'/smarty_template_forum_reply.html' : $this->paramArray[6];
		
		// define language -> $lang
		$lang = array();
		$path = $_SERVER['DOCUMENT_ROOT'];	
		if (substr($path, (strlen($path)-1)) == '/') $path = substr($path, 0, (strlen($path)-1));
		include_once ($path.CN_MODUL_BASEDIR.$this->modulUrl.'/language.php');
		$this->modul_lang = $lang;
		 
		// parse language
		$this->error_msg = $this->modul_lang[CN_LANGUAGE]['forum_not_configured'];
	}

	function pc_message_save() {
    
    		$parent_id = $_REQUEST['parent_id'];
    		
			$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
			$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
		
		    // is this message a reply?
		    if ($parent_id) {
		
		        // get the thread, level, and thread_pos of the parent message 
				$sql = "SELECT thread_id,level,thread_pos FROM cn_insert_mini_forum WHERE id = ".$parent_id;
				$res = $cnDatabase->Execute($sql);
        			$rowParent = $res->FetchRow();
        			
		        // a reply's level is one greater than its parents 
		        $level = $rowParent['level'] + 1;

		        /* what's the biggest thread_pos in this thread among messages with the same parent? */
		        $sql = "SELECT MAX(thread_pos) as 'max_thread_pos' FROM cn_insert_mini_forum WHERE thread_id = ".$rowParent['thread_id']." AND parent_id = ".$parent_id;
		        $res = $cnDatabase->Execute($sql);
		        $value = $res->FetchRow();
				
		        // are there existing replies to this parent?
		        if ($value['max_thread_pos']) {
		            // this thread_pos goes after the biggest existing one
		            $value['max_thread_pos']++;
		        } else {
		            // this is the first reply, so put it right after the parent 
		            $value['max_thread_pos'] = $rowParent['thread_pos'] + 1;
		        }
				$thread_pos = $value['max_thread_pos'];
		
		        // the new message should be saved with the parent's thread_id 
				$thread_id = $rowParent['thread_id'];
		
		        /* increment the thread_pos of all messages in the thread that come after this one */
		        $sql= "UPDATE cn_insert_mini_forum SET thread_pos = thread_pos + 1 WHERE thread_id = ".$thread_id." AND thread_pos >= ".$thread_pos;
				$res = $cnDatabase->Execute($sql);
		        
   			 } else {
   			 	
		        // the message is not a reply, so it's the start of a new thread 
		        $sql = "SELECT MAX(thread_id) as 'max_thread_id' FROM cn_insert_mini_forum";
		        $res = $cnDatabase->Execute($sql);
		        $value = $res->FetchRow();
		        $value['max_thread_id'] = (!$value['max_thread_id']) ? 0 : $value['max_thread_id'];
		        $thread_id = $value['max_thread_id']+1;
		        
		        $level = 0;
		        $thread_pos = 0;
		        $parent_id = 0;
		    }
		    
			    /* insert the message into the database. Using prepare() and execute() makes sure that all fields are properly quoted */
			    $sql = "INSERT INTO cn_insert_mini_forum 
								( thread_id, parent_id, thread_pos, posted_on, level, author, subject, body) 
			                  	VALUES
								( 
								'".$thread_id."',
								'".$parent_id."',
								'".$thread_pos."',
								NOW(),
								'".$level."',
								'".$_REQUEST['author']."',
								'".$_REQUEST['subject']."',
								'".$_REQUEST['body']."'
								)";
				
				$res = $cnDatabase->Execute($sql);
	}

	function pc_message_list() {
		
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
		
	    /* order the messages by their thread (thread_id) and their position within the thread (thread_pos) */
	    $sql = "SELECT `id`,`author`,`subject`,`posted_on`,`level` FROM cn_insert_mini_forum ORDER BY thread_id,thread_pos";
	    $res = $cnDatabase->Execute($sql);
  
	    while ($row = $res->fetchRow()) {
	        $out[] = $row;
	    }
	   return $out;
	              
	}

	function pc_message_read() {
		
		$id = $_REQUEST['id'];
		
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
	    
	    $sql = "SELECT * FROM cn_insert_mini_forum WHERE id = ".$id;
	    $res = $cnDatabase->Execute($sql);
	    $row = $res->fetchRow();
	    
	    $row['parent_id'] = $id;
		return $row;           
	}


	function pc_message_post($parent_id) {

    // is this message a reply
    if ($parent_id) {

        // send the parent_id along when the form is submitted
        $parent_field = '<input type="hidden" name="parent_id" value="'.$parent_id.'">';

        // if no subject's been passed in, use the subject of the parent
        if (!$_POST['subject']) {
        	
        		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
			$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
        		$sql = "SELECT * FROM cn_insert_mini_forum WHERE id = ".$parent_id;
        		$res = $cnDatabase->Execute($sql);
	    		$row = $res->fetchRow();

	    		$parent_subject = $row['subject'];
	    		$subject = htmlspecialchars($parent_subject);
	    		
	    		if ($parent_subject && (!preg_match('/^re:/i',$parent_subject))) $subject = 'Re: '.$subject;
        }
    }
    
	$row['subject'] = $subject;
	$row['parent_field'] = $parent_field;
            
    return  $row;
	}


	function cn_parse_insert_mini_forum() {
	
	// get pageid
	$this->pageid = $_GET['pageid'];
	$this->smarty->assign('pageid', $this->pageid);
	
	// get pageurl
	$this->smarty->assign('pageurl', cnEngine::cnGlobalUrlWrapper());

	// command
	switch ($_REQUEST['cmd']) {
		
			case 'read':
				$forum_content = $this->pc_message_read();
				$this->smarty->assign('subject', $forum_content['subject']);
				$this->smarty->assign('author', $forum_content['author']);
				$this->smarty->assign('body', $forum_content['body']);
				$this->smarty->assign('posted_on', $forum_content['posted_on']);
				$this->smarty->assign('parent_id', $forum_content['parent_id']);
				$out = $this->smarty->display($this->forum_template_detail);
			break;

			case 'post':    
			 	$parent_id = $_REQUEST['parent_id'];
				$forum_content = $this->pc_message_post($parent_id);
				$this->smarty->assign('subject', $forum_content['subject']);
				$this->smarty->assign('author', $forum_content['author']);
				$this->smarty->assign('body', $forum_content['body']);
				$this->smarty->assign('posted_on', $forum_content['posted_on']);
				$this->smarty->assign('parent_field', $forum_content['parent_field']);
				// switch normal post or reply template
				$template = ($parent_id) ? $this->forum_template_reply : $this->forum_template_post;
				$out = $this->smarty->display($template);
			break;

			case 'save':
				$this->pc_message_save();
				$this->smarty->assign('forum_content', $this->pc_message_list());
				$out = $this->smarty->display($this->forum_template_list);			          
			break;
			
			default:
			     $this->smarty->assign('forum_content', $this->pc_message_list());
			     $out = $this->smarty->display($this->forum_template_list);
			break;
		}		
		
		return $out;
	}
	
}

?>