<?php
/**
 *
 * ContentNow | Small Content Management System
 *
 * Copyright (C) 2005 Andre Michaelis <kontakt@michaelis-freunde.de>
 *
 * This file may be distributed and/or modified under the terms of the
 * "GNU General Public License" version 2 as published by the Free
 * Software Foundation and appearing in the file LICENSE included in
 * the packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 *
 * The "GNU General Public License" (GPL) is available at
 * http://www.gnu.org/copyleft/gpl.html.
 * 
 */

	// define basic params
	$modulName = 'Insert Mini Forum';
	$modulUrl = 'insert_mini_forum';
	$modulVersion = '0.18';
	$modulAuthor = 'andre@michaelis-freunde.de';	
	$modulDescription = 'Insert Mini Forum to contentnow. New databse table needed. You can customize the templates in the modul folder.';

	// install array additional database table
	$modulConf = array(
	'name' => $modulName,
	'version' => $modulVersion,
	'install_type' => 'db_install',
	'modulInstallMsg' => 	'Database needs to be updated. Continue?',
	'table_name' => 'cn_'.$modulUrl,
	'table' => array (
	
				"DROP TABLE IF EXISTS `cn_$modulUrl`;",

				"CREATE TABLE IF NOT EXISTS `cn_$modulUrl` (
				`id` INT NOT NULL auto_increment,
				`posted_on` DATETIME NOT NULL,
				`author` varchar(255) NOT NULL default '',
				`subject` varchar(255) NOT NULL default '',
				`body` MEDIUMTEXT NOT NULL default '',
				`thread_id` INT NOT NULL default '0',
				`parent_id` INT NOT NULL default '0',
				`level` INT NOT NULL default '0',
				`thread_pos` INT NOT NULL default '0',
				PRIMARY KEY  (`id`)
				)"
			)
	);

	// define individual params 
	/**
	 * array (input name, input type, param, contentParam),	
	 * @param	input name:
	 * 			input type:	chooseFile : param -> form name/id; contentParam -> (upload dir | upload type: file, dir | add single or multiple values)
	 * 						chooseID : 
	 * 						db : param -> display fields; contentParam -> edit fields
	 * 						input : 
	 */ 
					
	$params = array(
				array ('forum_template_list',		'chooseFile', 		'forum_template_list',		CN_UPLOAD_BASEDIR.'|file|single'),
				array ('forum_template_detail',	'chooseFile', 		'forum_template_detail',		CN_UPLOAD_BASEDIR.'|file|single'),
				array ('forum_template_post',		'chooseFile', 		'forum_template_post',		CN_UPLOAD_BASEDIR.'|file|single'),
				array ('forum_template_reply',	'chooseFile', 		'forum_template_reply',		CN_UPLOAD_BASEDIR.'|file|single'),
				array ('forum_template_function',	'functionFile', 		'',							'./modul/'.$modulUrl.'/save.php|_blank'),
				array ('forum_template_db',		'db', 				'author|subject',			'author|subject|body'),
	);
	
?>