<?php
/**
 *
 * ContentNow | Small Content Management System
 *
 * Copyright (C) 2005 Andre Michaelis <kontakt@michaelis-freunde.de>
 *
 * This file may be distributed and/or modified under the terms of the
 * "GNU General Public License" version 2 as published by the Free
 * Software Foundation and appearing in the file LICENSE included in
 * the packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 *
 * The "GNU General Public License" (GPL) is available at
 * http://www.gnu.org/copyleft/gpl.html.
 * 
 */

class cn_insert_news {

	function cn_insert_news ($smarty) {
		$this->smarty = $smarty;
	}
	
	function cn_init_insert_news ($obj) {
	
		$this->obj = $obj;
		$this->paramArray = explode('|*|',$this->obj['content']);
		
		// define basic params
		$this->modulID = $this->paramArray[0];
		$this->modulName = $this->paramArray[1];
		$this->modulUrl = $this->paramArray[2];
		
		// define individual params
		$this->news_pid = $this->paramArray[3];
		$this->news_detail_pid = $this->paramArray[4];
		$this->news_type = empty($this->paramArray[5]) ? 'list' : $this->paramArray[5];
		$this->news_latest_quantity = empty($this->paramArray[6]) ? 5 : $this->paramArray[6];
		$this->news_no_news_msg = empty($this->paramArray[7]) ? 'No News available.' : $this->paramArray[7];
		$this->news_template_list = empty($this->paramArray[8]) ? '../cn/modul/'.$this->modulUrl.'/smarty_template_news_list.html' : $this->paramArray[8];
		$this->news_template_detail = empty($this->paramArray[9]) ? '../cn/modul/'.$this->modulUrl.'/smarty_template_news_detail.html' : $this->paramArray[9];
		$this->news_template_latest = empty($this->paramArray[10]) ? '../cn/modul/'.$this->modulUrl.'/smarty_template_news_latest.html' : $this->paramArray[10];
		
		// define language -> $lang
		$lang = array();
		$path = $_SERVER['DOCUMENT_ROOT'];	
		if (substr($path, (strlen($path)-1)) == '/') $path = substr($path, 0, (strlen($path)-1));
		include_once ($path.CN_MODUL_BASEDIR.$this->modulUrl.'/language.php');
		$this->modul_lang = $lang;
		 
		// parse language
		$this->error_msg = $this->modul_lang[CN_LANGUAGE]['news_not_configured'];
		$this->error_msg_noid = $this->modul_lang[CN_LANGUAGE]['news_no_id'];
	}


	function cn_get_list_news () {
	
		// check if modul is configured and get news array
		if (empty($this->news_pid) or empty($this->news_detail_pid)) {

			// error
			$this->news_array[0]['content'] = $this->error_msg;
			
		} else {
		
			$where = explode(',',$this->news_pid);
			$whereSql = ' WHERE ( ';
			foreach ($where as $value) {
				$whereSql .= ' pid = '.$value.' OR';
			}		
			$whereSql = substr($whereSql,0,-3).' ) ';
			
			// get news	
			$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
			$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
			$sql = "SELECT * FROM ".CN_TBL_CONTENT.$whereSql." AND hidden = 0 AND deleted = 0 AND contenttype = 0 ORDER by sort ASC";
			$res = $cnDatabase->Execute($sql);
			
			// check entries
			if ($res->RecordCount() > 0) {
				while( $row = $res->FetchRow()) {
					$this->news_array[] = $row;
				}
			} else {
			// if no news found
				$this->news_array[0]['content'] = $this->news_no_news_msg;
			}
		}

	}
	
	function cn_get_single_news () {
	
		// get single news array
		$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
		$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
		$sql = "SELECT * FROM ".CN_TBL_CONTENT." WHERE id = ".$this->newsID." AND hidden = 0 AND deleted = 0 ORDER by sort ASC";
		$res = $cnDatabase->Execute($sql);
		if ($res->RecordCount() > 0) {
			while( $row = $res->FetchRow()) {
				$this->news_array[] = $row;
			}
		} else {
			// if no news found
			$this->news_array[0]['content'] = $this->news_no_news_msg;
		}
	}	
	
	function cn_get_latest_news () {
	
		// check if modul is configured and get news array
		if (empty($this->news_pid) or empty($this->news_detail_pid)) {
		
			// error
			$this->news_array[0]['content'] = $this->error_msg;

		} else {

			// get news
			$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
			$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);
			$sql = "SELECT * FROM ".CN_TBL_CONTENT." WHERE pid = ".$this->news_pid." AND hidden = 0 AND deleted = 0 AND contenttype = 0 ORDER by sort ASC";
			$res = $cnDatabase->Execute($sql);
			
			// check entries
			if ($res->RecordCount() > 0) {
				for ($i=0; $i<$this->news_latest_quantity; $i++) {
					$this->news_array[] = $res->FetchRow();
				}

			} else {
				// if no news found
				$this->news_array[0]['content'] = $this->news_no_news_msg;
			}
			
		}
		
	}
	
	function cn_parse_insert_news() {
	
		switch ($this->news_type) {		
			case "single":
				$this->newsID = $_GET['newsid'];
				if ( empty($this->newsID) ) {
					$out = 	$this->error_msg_noid;
				} else {
					$this->cn_get_single_news();
					$this->smarty->assign('news_array', $this->news_array);
					$out = $this->smarty->display($this->news_template_detail);
				}
			break;
	
			case "list":
				$this->cn_get_list_news();
				$this->smarty->assign('news_detail_pid', $this->news_detail_pid);
				$this->smarty->assign('news_array', $this->news_array);
				$out = $this->smarty->display($this->news_template_list);
			break;		
			
			case "latest":
				$this->cn_get_latest_news();
				$this->smarty->assign('news_detail_pid', $this->news_detail_pid);
				$this->smarty->assign('news_array', $this->news_array);
				$out = $this->smarty->display($this->news_template_latest);		
			break;	
		}
		
		return $out;
	}
	
}

?>