<?php
/**
 *
 * ContentNow | Small Content Management System
 *
 * Copyright (C) 2005 Andre Michaelis <kontakt@michaelis-freunde.de>
 *
 * This file may be distributed and/or modified under the terms of the
 * "GNU General Public License" version 2 as published by the Free
 * Software Foundation and appearing in the file LICENSE included in
 * the packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 *
 * The "GNU General Public License" (GPL) is available at
 * http://www.gnu.org/copyleft/gpl.html.
 *
 */

class cn_insert_search {

	function cn_insert_search ($smarty) {
		$this->smarty = $smarty;
	}

	function cn_init_insert_search ($obj) {

		$this->obj = $obj;
		$this->paramArray = explode('|*|',$this->obj['content']);

		// define basic params
		$this->modulID = $this->paramArray[0];
		$this->modulName = $this->paramArray[1];
		$this->modulUrl = $this->paramArray[2];

		// define individual params
		$this->search_template = empty($this->paramArray[3]) ? '../cn/modul/'.$this->modulUrl.'/smarty_template_search.html' : $this->paramArray[3];
		$this->search_template_detail = empty($this->paramArray[4]) ? '../cn/modul/'.$this->modulUrl.'/smarty_template_search_detail.html' : $this->paramArray[4];
		$this->search_text = empty($this->paramArray[5]) ? 'Please enter your search ...' : $this->paramArray[5];
		$this->search_no_result_msg = empty($this->paramArray[6]) ? 'Nothing found ...' : $this->paramArray[6];
		$this->search_insert_string = empty($this->paramArray[7]) ? 'Enter search string ...' : $this->paramArray[7];
		$this->search_result_msg = empty($this->paramArray[8]) ? 'Results found: ' : $this->paramArray[8];
		$this->search_button = empty($this->paramArray[9]) ? 'Start search' : $this->paramArray[9];
		$this->search_show_result = empty($this->paramArray[10]) ? 'Show page' : $this->paramArray[10];

	}


	function cn_get_search_result ($string) {

			$cnDatabase = NewADOConnection(ADODB_DB_TYPE);
			$cnDatabase->Connect(CN_DB_HOST, CN_DB_USER, CN_DB_PASSWORD, CN_DB_NAME);

			$remove = array('/','+','.',':');
			$replacement = '';
			$pieces = explode('&', str_replace($remove,$replacement,$string));

			foreach ($pieces as $value) {
				$value = trim($value);
				$query = "AND ( content LIKE '%".$value."%' OR contenttitle LIKE '%".$value."%' OR contentsubtitle LIKE '%".$value."%' ) ";
			}

			// get language
			$getLanguage = empty($_GET['clang']) ? '' : '_'.$_GET['clang'];

			// get result
			$sql = "SELECT * FROM ".CN_TBL_CONTENT.$getLanguage." WHERE ( contenttype = 0 ) ".$query." ORDER by tstamp DESC";
			$res = $cnDatabase->Execute($sql);
			if ($res->RecordCount() > 0) {
				while ($row = $res->FetchRow()) {
					$searchArray[] = $row;
				}
			}
			return $searchArray;
	}

	function cn_parse_insert_search() {

				$this->smarty->assign('search_formurl', cnEngine::cnGlobalUrlWrapper());
				$this->smarty->assign('search_button',$this->search_button);
				$this->smarty->assign('search_show_result', $this->search_show_result);

				if ($_POST['submit_search']) {

						if (empty($_POST['search_string'])) {

							// no search value entered
							$this->smarty->assign('search_msg', $this->search_insert_string);
							$this->smarty->assign('search_string', '');
							$this->smarty->assign('search_result', '' );
							$this->smarty->assign('search_text', $this->search_text );

						} else {

							// get results
							// TODO implement security for sql injection
							$search_result = $this->cn_get_search_result(rawurlencode($_POST['search_string']));

							if (empty($search_result)) {

								// no results
								$this->smarty->assign('search_msg', $this->search_no_result_msg);
								$this->smarty->assign('search_string', $_POST['search_string']);
								$this->smarty->assign('search_result', '' );
								$this->smarty->assign('search_text', $this->search_text );

							} else {

								// assign results
								$this->smarty->assign('search_msg', $this->search_result_msg.count($search_result));
								$this->smarty->assign('search_string', $_POST['search_string']);
								$this->smarty->assign('search_result', $search_result );
								$this->smarty->assign('search_text', '' );
							}

						}

					$out = $this->smarty->fetch($this->search_template_detail);

				} else {

					$this->smarty->assign('search_text', $this->search_text );
					$out = $this->smarty->fetch($this->search_template);
				}

		return $out;
	}

}

?>