<?php
/**
 *
 * ContentNow | Small Content Management System
 *
 * Copyright (C) 2005/2006 Andre Michaelis <kontakt@michaelis-freunde.de>
 *
 * This file may be distributed and/or modified under the terms of the
 * "GNU General Public License" version 2 as published by the Free
 * Software Foundation and appearing in the file LICENSE included in
 * the packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 *
 * The "GNU General Public License" (GPL) is available at
 * http://www.gnu.org/copyleft/gpl.html.
 *
 */

/* get contentnow classes */

	if (   file_exists ('./cn/library/configure.php') ) {
		require_once ('./cn/library/configure.php');
	} else {
		die ('<span style="font:13px sans-serif;">Please install contentNow.</span>');
	}

	if (   file_exists ('./cn/adodb/adodb.inc.php')
		&& file_exists ('./cn/smarty/Smarty.class.php')
		&& file_exists ('./cn/library/class.engine.php')
		&& file_exists ('./cn/library/class.tree.php')
		&& file_exists ('./cn/library/class.session.php')
		) {
		require_once ('./cn/adodb/adodb.inc.php');
		require_once ('./cn/smarty/Smarty.class.php');
		require_once ('./cn/library/class.engine.php');
		require_once ('./cn/library/class.tree.php');
		require_once ('./cn/library/class.session.php');
	} else {
		die ('<span style="font:13px sans-serif;">Fatal error loading classes, please contact Webmaster.</span>');
	}

	// init cnEngine
	$cnEngine = new cnEngine();

	// get/set language frontend, security check language string
	$setCLang = (empty($_GET['clang'])) ? '' : $_GET['clang'] == 'default' ? '' : $_GET['clang'];

	// only check if alternative language installed, else default
	if (!empty($setCLang)) {
		if (false == $cnEngine->checkContentLanguage($setCLang)) die ('<span style="font:13px sans-serif;">Error loading language. No language available.</span>');
	} else {
		$setCLang = CN_CONTENT_LANGUAGE;
	}
	$cnEngine->setContentLanguage($setCLang);

	// get config
	$cnEngine->getConfigPage();

	// get/set id or startpageid from config
	$pid = $_GET['pageid'];
	if (empty($pid) || $pid == 1) $pid = $cnEngine->configArray[0]['startpageid'];
	if (false == $cnEngine->checkPid($pid)) die ('<span style="font:13px sans-serif;">Error loading site. No pid found.</span>');
	$cnEngine->setId($pid);

/* get content and navigation */

	// get actual content (param hidden = 0 => no hidden content)
	// inline editing for modul content in smarty/function.cnmodul.php
	if ($_GET['inline'] == 1) {
		// check authorisation for inline edit
		$cnSession = new cnSession();
		$cnSession->checkAuthentication();
		// get content
		$cnEngine->getActualPreviewContent();
		// get teaser content
		$cnEngine->getTeaserPreviewContent('AND contenttype = 1');
	} else {
		// get content		
		$cnEngine->getActualContent('AND hidden = 0 AND starttime < '.strtotime("now").' AND endtime > '.strtotime("now"));
		// get teaser content
		$cnEngine->getTeaserContent('AND hidden = 0 AND contenttype = 1 AND starttime < '.strtotime("now").' AND endtime > '.strtotime("now"));
	}

	// override content for single teaser
	$cnEngine->parseTeaserContent();

	// get navigation array include actual pageinfo and sitemap array
	$cnEngine->getNavigationArray();

	// get level 1,2, ... ,n navigation
	$cnEngine->getSubNavigationArray();

	// get clickpath navigation -> include actual page
	$cnEngine->getClickPathArray();

/* configure templates */

	// set mastertemplate (local template or global template)
	if (empty($cnEngine->mtemplate)) {
		$mastertemplate = $cnEngine->configArray[0]['mastertemplate'];
	} else {
		$mastertemplate = $cnEngine->mtemplate;
	}
	if (empty($mastertemplate)) die ('<span style="font:13px sans-serif;">Error loading page. No template defined.</span>');

	// set contenttemplate (local template or global template)
	if (empty($cnEngine->template)) {
		$contentpagetemplate = $cnEngine->configArray[0]['contenttemplate'];
	} else {
		$contentpagetemplate = $cnEngine->template;
	}
	if (empty($contentpagetemplate)) die ('<span style="font:13px sans-serif;">Error loading page. No template defined.</span>');

	// set printtemplate (if no global set to mastertemplate)
	if (empty($cnEngine->configArray[0]['printtemplate'])) {
		$printtemplate = $cnEngine->configArray[0]['mastertemplate'];
	} else {
		$printtemplate =$cnEngine->configArray[0]['printtemplate'];
	}

	// set specialtemplate (if no global set to mastertemplate)
	if (empty($cnEngine->configArray[0]['specialtemplate'])) {
		$specialtemplate = $cnEngine->configArray[0]['mastertemplate'];
	} else {
		$specialtemplate = $cnEngine->configArray[0]['specialtemplate'];
	}

	// set pageimage  (if no local pageimage set to global)
	if (empty($cnEngine->pageimage)) {
		$pageimageurl = $cnEngine->configArray[0]['globalpageimage'];
	} else {
		$pageimageurl = $cnEngine->pageimage;
	}

	// set syskey  (if no local syskey set to global)
	if (empty($cnEngine->syskey)) {
		$syskey = $cnEngine->configArray[0]['globalsyskey'];
	} else {
		$syskey = $cnEngine->syskey;
	}

	// set footer header template
	$pagefootertemplate = $cnEngine->configArray[0]['pagefootertemplate'];
	$pageheadertemplate = $cnEngine->configArray[0]['pageheadertemplate'];

/* Smarty */

	// Init smarty
	$smarty = new Smarty();
	$smarty->template_dir = 'upload/';
	$smarty->compile_dir = 'cn/smarty/templates_c';
	$smarty->cache_dir = 'cn/smarty/cache';
	$smarty->config_dir = 'cn/smarty/configs';
	if ($cnEngine->configArray[0]['smartycache'] == 1)	$smarty->caching = true;

	// content
	// type 0 (content) -> normal output
	// type 1 (teaser content) -> normal output
	// type 2 (dynamic php) -> normal output including php script
	// type 3 (modul) -> parsed to smarty plugin (smarty/function.cnmodul.php)
	$smarty->assign('contentArray', $cnEngine->contentArray);
	$smarty->assign('teaserContentArray', $cnEngine->teaserContentArray);

	// navigation
	$smarty->assign('navigationArray', $cnEngine->navigationArray);
	$smarty->assign('subNavigationArray', $cnEngine->subNavigationArray);
	$smarty->assign('clickPathArray', $cnEngine->clickPathArray);
	$smarty->assign('siteMapArray', $cnEngine->siteMapArray);

	// assign page variables
	$smarty->assign('rootNodeID', $cnEngine->rootNodeID);
	$smarty->assign('rootNodeName', $cnEngine->rootNodeName);
	$smarty->assign('parentNodeID', $cnEngine->parentNodeID);
	$smarty->assign('parentNodeName', $cnEngine->parentNodeName);
	$smarty->assign('pageidroot', CN_IDROOT);
	$smarty->assign('startpageid', $cnEngine->configArray[0]['startpageid']);
	$smarty->assign('pageid', $cnEngine->pageid);
	$smarty->assign('pagename', $cnEngine->pagename);
	$smarty->assign('pagelevel', $cnEngine->pagelevel);
	$smarty->assign('template', $cnEngine->template);
	$smarty->assign('pageimageurl', $pageimageurl);
	$smarty->assign('syskey', $syskey);
	$smarty->assign('description', $cnEngine->description);
	$smarty->assign('metainfo', $cnEngine->configArray[0]['metainfo']);
	$smarty->assign('metadescription', $cnEngine->configArray[0]['metadescription']);
	$smarty->assign('metakeywords', $cnEngine->configArray[0]['metakeywords']);
	$smarty->assign('sitetitle', $cnEngine->configArray[0]['sitetitle']);
	$smarty->assign('uploaddir', CN_UPLOAD_BASEDIR);
	$smarty->assign('contentpagetemplate', $contentpagetemplate);

	//check inline edit
	$inlineEdit = ($_GET['inline'] == 1) ? '&inline=1' : '';

	// normal mode
	$smarty->assign('baseurl', 'index.php?pageid=');
	$smarty->assign('baseurlsuffix', empty($setCLang) ? $inlineEdit : $inlineEdit.'&clang='.$setCLang);
	// rewrite mode
	//$smarty->assign('baseurl', 'seite_');
	//$smarty->assign('baseurlsuffix', '.html');

	// fetch constants
	$smarty->fetch('../cn/constants.php');

	// fetch smarty content pageimage
	if (!empty($pageimageurl)) {
		$pageimage = $smarty->fetch($cnEngine->configArray[0]['pageimagetemplate'],$cnEngine->getId());
		$smarty->assign('pageimage', $pageimage);
	}

	// fetch smarty content
	$content = $smarty->fetch($contentpagetemplate,$cnEngine->getId());
	$smarty->assign('content', $content);

	// fetch smarty teaser
	$teasercontent = $smarty->fetch($cnEngine->configArray[0]['teasercontenttemplate'],$cnEngine->getId());
	$smarty->assign('teaser', $teasercontent);

	// fetch smarty navigation level 2
	$navigation_l2 = $smarty->fetch($cnEngine->configArray[0]['navigationl2'],$cnEngine->getId());
	$smarty->assign('navigation_l2', $navigation_l2);

	// fetch smarty navigation level 1
	$navigation_l1 = $smarty->fetch($cnEngine->configArray[0]['navigationl1'],$cnEngine->getId());
	$smarty->assign('navigation_l1', $navigation_l1);

	// fetch smarty content pagefooter
	if (!empty($pagefootertemplate)) {
		$footer = $smarty->fetch($pagefootertemplate);
		$smarty->assign('footer', $footer);
	}
	// fetch smarty content pageheader
	if (!empty($pageheadertemplate)) {
		$header = $smarty->fetch($pageheadertemplate);
		$smarty->assign('header', $header);
	}

/* generate content */

	switch ($_GET['screen']) {

		default:
		// Display default Site Screen
		if ($cnEngine->previewMode == true )
		$smarty->load_filter('output', 'cnpreview');
		$smarty->load_filter('output', 'cnadd');
		$smarty->display($mastertemplate,$cnEngine->getId());
		break;

		case "special":
		// Display Site Special/Text (Barrierefrei)
		if ($cnEngine->previewMode == true )
		$smarty->load_filter('output', 'cnpreview');
		$smarty->load_filter('output', 'cnadd');
		$smarty->display($specialtemplate,$cnEngine->getId());
		break;

		case "print":
		// Display Site Print
		$smarty->display($printtemplate,$cnEngine->getId());
		break;

		 case "pdf":
		// Display Site PDF (FPDF) experimental
		require_once ('./cn/plugin/fpdf/fpdf.php');
		require_once ('./cn/plugin/fpdf/fpdf.writetag.php');
		$contentpdf = $smarty->fetch('upload_admin/templates/contentpdf.html',$cnEngine->getId());
		include_once ('./cn/plugin/fpdf/pdf.php');
		break;
	}
?>